/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         sieveparse
#define yylex           sievelex
#define yyerror         sieveerror
#define yydebug         sievedebug
#define yynerrs         sievenerrs

/* First part of user prologue.  */
#line 1 "sieve/sieve.y"

/* sieve.y -- sieve parser
 * Larry Greenfield
 * Ken Murchison
 *
 * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The name "Carnegie Mellon University" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission. For permission or any legal
 *    details, please contact
 *      Carnegie Mellon University
 *      Center for Technology Transfer and Enterprise Creation
 *      4615 Forbes Avenue
 *      Suite 302
 *      Pittsburgh, PA  15213
 *      (412) 268-7393, fax: (412) 268-7395
 *      innovation@andrew.cmu.edu
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by Computing Services
 *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
 *
 * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
 * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
 * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * Yacc definitions
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "xmalloc.h"
#include "sieve/bytecode.h"
#include "sieve/comparator.h"
#include "sieve/interp.h"
#include "sieve/script.h"
#include "sieve/tree.h"
#include "sieve/flags.h"
#include "sieve/grammar.h"
#include "sieve/sieve_err.h"

#include "util.h"
#include "imparse.h"
#include "libconfig.h"
#include "times.h"
#include "tok.h"

#define ERR_BUF_SIZE 1024

int encoded_char = 0;    /* used to send encoded-character feedback to lexer */
static comp_t *ctags;    /* used for accessing comp_t* in a test/command union */
static int *copy;        /* used for accessing copy flag in a command union */
static int *create;      /* used for accessing create flag in a command union */
static strarray_t **flags; /* used for accessing imap flags in a command union */
static char **specialuse; /* used for accessing special-use flag in a command */
static char **mailboxid; /* used for accessing mailboxid in a command */
static char **fccfolder; /* used for accessing fcc.folder in a command */
static unsigned bctype;  /* used to set the bytecode command type in mtags */

extern int addrparse(sieve_script_t*);
typedef struct yy_buffer_state *YY_BUFFER_STATE;
extern YY_BUFFER_STATE addr_scan_string(const char*);
extern void addr_delete_buffer(YY_BUFFER_STATE);

extern int sievelineno;

void sieveerror_c(sieve_script_t*, int code, ...);

static int check_reqs(sieve_script_t*, strarray_t *sl);
static int chk_match_vars(sieve_script_t*, char *s);

static unsigned bc_precompile(cmdarg_t args[], const char *fmt, ...);

/* construct/canonicalize action commands */
static commandlist_t *build_keep(sieve_script_t*, commandlist_t *c);
static commandlist_t *build_fileinto(sieve_script_t*,
                                     commandlist_t *c, char *folder);
static commandlist_t *build_redirect(sieve_script_t*,
                                     commandlist_t *c, char *addr);
static commandlist_t *build_rej_err(sieve_script_t*, int t, char *message);
static commandlist_t *build_vacation(sieve_script_t*, commandlist_t *t, char *s);
static commandlist_t *build_flag(sieve_script_t*,
                                 commandlist_t *c, strarray_t *flags);
static commandlist_t *build_notify(sieve_script_t*, int t,
                                   commandlist_t *c, char *method);
static commandlist_t *build_denotify(sieve_script_t*, commandlist_t *c);
static commandlist_t *build_include(sieve_script_t*, commandlist_t *c, char*);
static commandlist_t *build_set(sieve_script_t*, commandlist_t *c,
                                char *variable, char *value);
static commandlist_t *build_addheader(sieve_script_t*, commandlist_t *c,
                                      char *name, char *value);
static commandlist_t *build_deleteheader(sieve_script_t*, commandlist_t *c,
                                         char *name, strarray_t *values);
static commandlist_t *build_log(sieve_script_t*, char *text);
static commandlist_t *build_snooze(sieve_script_t *sscript,
                                   commandlist_t *c, arrayu64_t *times);
static commandlist_t *build_imip(sieve_script_t *sscript, commandlist_t *t);

/* construct/canonicalize test commands */
static test_t *build_anyof(sieve_script_t*, testlist_t *tl);
static test_t *build_allof(sieve_script_t*, testlist_t *tl);
static test_t *build_not(sieve_script_t*, test_t *t);
static test_t *build_address(sieve_script_t*, test_t *t,
                             strarray_t *sl, strarray_t *pl);
static test_t *build_envelope(sieve_script_t*, test_t *t,
                              strarray_t *sl, strarray_t *pl);
static test_t *build_header(sieve_script_t*, test_t *t,
                            strarray_t *sl, strarray_t *pl);
static test_t *build_body(sieve_script_t*, test_t *t, strarray_t *pl);
static test_t *build_stringt(sieve_script_t*, test_t *t,
                             strarray_t *sl, strarray_t *pl);
static test_t *build_hasflag(sieve_script_t*, test_t *t,
                             strarray_t *sl, strarray_t *pl);
static test_t *build_date(sieve_script_t*, test_t *t,
                          char *hn, char *part, strarray_t *kl);
static test_t *build_ihave(sieve_script_t*, strarray_t *sa);
static test_t *build_mbox_meta(sieve_script_t*, test_t *t, char *extname,
                               char *keyname, strarray_t *keylist);
static test_t *build_duplicate(sieve_script_t*, test_t *t);
static test_t *build_jmapquery(sieve_script_t*, test_t *t, char *json);

static int verify_weekday(sieve_script_t *sscript, char *day);
static int verify_time(sieve_script_t *sscript, char *time);

void yyerror(sieve_script_t*, const char *msg);
extern int yylex(void*, sieve_script_t*);
extern void sieverestart(FILE *f);

#define supported(capa) (sscript->support & capa)

#define _verify_flaglist(flags) \
  (supported(SIEVE_CAPA_VARIABLES) || verify_flaglist(flags))

#define YYERROR_VERBOSE /* I want better error messages! */

/* byacc default is 500, bison default is 10000 - go with the
   larger to support big sieve scripts (see Bug #3461) */
#define YYSTACKSIZE 10000

#line 241 "sieve/sieve.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_SIEVE_SIEVE_SIEVE_H_INCLUDED
# define YY_SIEVE_SIEVE_SIEVE_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int sievedebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    NUMBER = 258,                  /* NUMBER  */
    STRING = 259,                  /* STRING  */
    IF = 260,                      /* IF  */
    ELSIF = 261,                   /* ELSIF  */
    ELSE = 262,                    /* ELSE  */
    REQUIRE = 263,                 /* REQUIRE  */
    STOP = 264,                    /* STOP  */
    DISCARD = 265,                 /* DISCARD  */
    KEEP = 266,                    /* KEEP  */
    FILEINTO = 267,                /* FILEINTO  */
    REDIRECT = 268,                /* REDIRECT  */
    ANYOF = 269,                   /* ANYOF  */
    ALLOF = 270,                   /* ALLOF  */
    EXISTS = 271,                  /* EXISTS  */
    NOT = 272,                     /* NOT  */
    SFALSE = 273,                  /* SFALSE  */
    STRUE = 274,                   /* STRUE  */
    SIZE = 275,                    /* SIZE  */
    HEADERT = 276,                 /* HEADERT  */
    ADDRESS = 277,                 /* ADDRESS  */
    ENVELOPE = 278,                /* ENVELOPE  */
    COMPARATOR = 279,              /* COMPARATOR  */
    OVER = 280,                    /* OVER  */
    UNDER = 281,                   /* UNDER  */
    ALL = 282,                     /* ALL  */
    LOCALPART = 283,               /* LOCALPART  */
    DOMAIN = 284,                  /* DOMAIN  */
    IS = 285,                      /* IS  */
    CONTAINS = 286,                /* CONTAINS  */
    MATCHES = 287,                 /* MATCHES  */
    OCTET = 288,                   /* OCTET  */
    ASCIICASEMAP = 289,            /* ASCIICASEMAP  */
    ASCIINUMERIC = 290,            /* ASCIINUMERIC  */
    REGEX = 291,                   /* REGEX  */
    QUOTEREGEX = 292,              /* QUOTEREGEX  */
    COPY = 293,                    /* COPY  */
    BODY = 294,                    /* BODY  */
    RAW = 295,                     /* RAW  */
    TEXT = 296,                    /* TEXT  */
    CONTENT = 297,                 /* CONTENT  */
    ENVIRONMENT = 298,             /* ENVIRONMENT  */
    STRINGT = 299,                 /* STRINGT  */
    SET = 300,                     /* SET  */
    LOWER = 301,                   /* LOWER  */
    UPPER = 302,                   /* UPPER  */
    LOWERFIRST = 303,              /* LOWERFIRST  */
    UPPERFIRST = 304,              /* UPPERFIRST  */
    QUOTEWILDCARD = 305,           /* QUOTEWILDCARD  */
    LENGTH = 306,                  /* LENGTH  */
    VACATION = 307,                /* VACATION  */
    DAYS = 308,                    /* DAYS  */
    SUBJECT = 309,                 /* SUBJECT  */
    FROM = 310,                    /* FROM  */
    ADDRESSES = 311,               /* ADDRESSES  */
    MIME = 312,                    /* MIME  */
    HANDLE = 313,                  /* HANDLE  */
    SECONDS = 314,                 /* SECONDS  */
    COUNT = 315,                   /* COUNT  */
    VALUE = 316,                   /* VALUE  */
    GT = 317,                      /* GT  */
    GE = 318,                      /* GE  */
    LT = 319,                      /* LT  */
    LE = 320,                      /* LE  */
    EQ = 321,                      /* EQ  */
    NE = 322,                      /* NE  */
    FLAGS = 323,                   /* FLAGS  */
    HASFLAG = 324,                 /* HASFLAG  */
    SETFLAG = 325,                 /* SETFLAG  */
    ADDFLAG = 326,                 /* ADDFLAG  */
    REMOVEFLAG = 327,              /* REMOVEFLAG  */
    MARK = 328,                    /* MARK  */
    UNMARK = 329,                  /* UNMARK  */
    USER = 330,                    /* USER  */
    DETAIL = 331,                  /* DETAIL  */
    DATE = 332,                    /* DATE  */
    CURRENTDATE = 333,             /* CURRENTDATE  */
    ORIGINALZONE = 334,            /* ORIGINALZONE  */
    ZONE = 335,                    /* ZONE  */
    INDEX = 336,                   /* INDEX  */
    LAST = 337,                    /* LAST  */
    ADDHEADER = 338,               /* ADDHEADER  */
    DELETEHEADER = 339,            /* DELETEHEADER  */
    REJCT = 340,                   /* REJCT  */
    EREJECT = 341,                 /* EREJECT  */
    METHOD = 342,                  /* METHOD  */
    OPTIONS = 343,                 /* OPTIONS  */
    MESSAGE = 344,                 /* MESSAGE  */
    IMPORTANCE = 345,              /* IMPORTANCE  */
    VALIDNOTIFYMETHOD = 346,       /* VALIDNOTIFYMETHOD  */
    NOTIFYMETHODCAPABILITY = 347,  /* NOTIFYMETHODCAPABILITY  */
    NOTIFY = 348,                  /* NOTIFY  */
    ENOTIFY = 349,                 /* ENOTIFY  */
    ENCODEURL = 350,               /* ENCODEURL  */
    DENOTIFY = 351,                /* DENOTIFY  */
    NID = 352,                     /* NID  */
    ANY = 353,                     /* ANY  */
    LOW = 354,                     /* LOW  */
    NORMAL = 355,                  /* NORMAL  */
    HIGH = 356,                    /* HIGH  */
    IHAVE = 357,                   /* IHAVE  */
    ERROR = 358,                   /* ERROR  */
    MAILBOXEXISTS = 359,           /* MAILBOXEXISTS  */
    CREATE = 360,                  /* CREATE  */
    METADATA = 361,                /* METADATA  */
    METADATAEXISTS = 362,          /* METADATAEXISTS  */
    SERVERMETADATA = 363,          /* SERVERMETADATA  */
    SERVERMETADATAEXISTS = 364,    /* SERVERMETADATAEXISTS  */
    BYTIMEREL = 365,               /* BYTIMEREL  */
    BYTIMEABS = 366,               /* BYTIMEABS  */
    BYMODE = 367,                  /* BYMODE  */
    BYTRACE = 368,                 /* BYTRACE  */
    DSNNOTIFY = 369,               /* DSNNOTIFY  */
    DSNRET = 370,                  /* DSNRET  */
    VALIDEXTLIST = 371,            /* VALIDEXTLIST  */
    LIST = 372,                    /* LIST  */
    INCLUDE = 373,                 /* INCLUDE  */
    OPTIONAL = 374,                /* OPTIONAL  */
    ONCE = 375,                    /* ONCE  */
    RETURN = 376,                  /* RETURN  */
    PERSONAL = 377,                /* PERSONAL  */
    GLOBAL = 378,                  /* GLOBAL  */
    DUPLICATE = 379,               /* DUPLICATE  */
    HEADER = 380,                  /* HEADER  */
    UNIQUEID = 381,                /* UNIQUEID  */
    SPECIALUSEEXISTS = 382,        /* SPECIALUSEEXISTS  */
    SPECIALUSE = 383,              /* SPECIALUSE  */
    FCC = 384,                     /* FCC  */
    MAILBOXID = 385,               /* MAILBOXID  */
    MAILBOXIDEXISTS = 386,         /* MAILBOXIDEXISTS  */
    SNOOZE = 387,                  /* SNOOZE  */
    MAILBOX = 388,                 /* MAILBOX  */
    ADDFLAGS = 389,                /* ADDFLAGS  */
    REMOVEFLAGS = 390,             /* REMOVEFLAGS  */
    WEEKDAYS = 391,                /* WEEKDAYS  */
    TZID = 392,                    /* TZID  */
    LOG = 393,                     /* LOG  */
    JMAPQUERY = 394,               /* JMAPQUERY  */
    PROCESSIMIP = 395,             /* PROCESSIMIP  */
    INVITESONLY = 396,             /* INVITESONLY  */
    UPDATESONLY = 397,             /* UPDATESONLY  */
    DELETECANCELED = 398,          /* DELETECANCELED  */
    CALENDARID = 399,              /* CALENDARID  */
    OUTCOME = 400,                 /* OUTCOME  */
    ERRSTR = 401                   /* ERRSTR  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define NUMBER 258
#define STRING 259
#define IF 260
#define ELSIF 261
#define ELSE 262
#define REQUIRE 263
#define STOP 264
#define DISCARD 265
#define KEEP 266
#define FILEINTO 267
#define REDIRECT 268
#define ANYOF 269
#define ALLOF 270
#define EXISTS 271
#define NOT 272
#define SFALSE 273
#define STRUE 274
#define SIZE 275
#define HEADERT 276
#define ADDRESS 277
#define ENVELOPE 278
#define COMPARATOR 279
#define OVER 280
#define UNDER 281
#define ALL 282
#define LOCALPART 283
#define DOMAIN 284
#define IS 285
#define CONTAINS 286
#define MATCHES 287
#define OCTET 288
#define ASCIICASEMAP 289
#define ASCIINUMERIC 290
#define REGEX 291
#define QUOTEREGEX 292
#define COPY 293
#define BODY 294
#define RAW 295
#define TEXT 296
#define CONTENT 297
#define ENVIRONMENT 298
#define STRINGT 299
#define SET 300
#define LOWER 301
#define UPPER 302
#define LOWERFIRST 303
#define UPPERFIRST 304
#define QUOTEWILDCARD 305
#define LENGTH 306
#define VACATION 307
#define DAYS 308
#define SUBJECT 309
#define FROM 310
#define ADDRESSES 311
#define MIME 312
#define HANDLE 313
#define SECONDS 314
#define COUNT 315
#define VALUE 316
#define GT 317
#define GE 318
#define LT 319
#define LE 320
#define EQ 321
#define NE 322
#define FLAGS 323
#define HASFLAG 324
#define SETFLAG 325
#define ADDFLAG 326
#define REMOVEFLAG 327
#define MARK 328
#define UNMARK 329
#define USER 330
#define DETAIL 331
#define DATE 332
#define CURRENTDATE 333
#define ORIGINALZONE 334
#define ZONE 335
#define INDEX 336
#define LAST 337
#define ADDHEADER 338
#define DELETEHEADER 339
#define REJCT 340
#define EREJECT 341
#define METHOD 342
#define OPTIONS 343
#define MESSAGE 344
#define IMPORTANCE 345
#define VALIDNOTIFYMETHOD 346
#define NOTIFYMETHODCAPABILITY 347
#define NOTIFY 348
#define ENOTIFY 349
#define ENCODEURL 350
#define DENOTIFY 351
#define NID 352
#define ANY 353
#define LOW 354
#define NORMAL 355
#define HIGH 356
#define IHAVE 357
#define ERROR 358
#define MAILBOXEXISTS 359
#define CREATE 360
#define METADATA 361
#define METADATAEXISTS 362
#define SERVERMETADATA 363
#define SERVERMETADATAEXISTS 364
#define BYTIMEREL 365
#define BYTIMEABS 366
#define BYMODE 367
#define BYTRACE 368
#define DSNNOTIFY 369
#define DSNRET 370
#define VALIDEXTLIST 371
#define LIST 372
#define INCLUDE 373
#define OPTIONAL 374
#define ONCE 375
#define RETURN 376
#define PERSONAL 377
#define GLOBAL 378
#define DUPLICATE 379
#define HEADER 380
#define UNIQUEID 381
#define SPECIALUSEEXISTS 382
#define SPECIALUSE 383
#define FCC 384
#define MAILBOXID 385
#define MAILBOXIDEXISTS 386
#define SNOOZE 387
#define MAILBOX 388
#define ADDFLAGS 389
#define REMOVEFLAGS 390
#define WEEKDAYS 391
#define TZID 392
#define LOG 393
#define JMAPQUERY 394
#define PROCESSIMIP 395
#define INVITESONLY 396
#define UPDATESONLY 397
#define DELETECANCELED 398
#define CALENDARID 399
#define OUTCOME 400
#define ERRSTR 401

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 179 "sieve/sieve.y"

    int nval;
    char *sval;
    arrayu64_t *nl;
    strarray_t *sl;
    comp_t *ctag;
    test_t *test;
    testlist_t *testl;
    commandlist_t *cl;

#line 597 "sieve/sieve.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif




int sieveparse (sieve_script_t *sscript);


#endif /* !YY_SIEVE_SIEVE_SIEVE_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_NUMBER = 3,                     /* NUMBER  */
  YYSYMBOL_STRING = 4,                     /* STRING  */
  YYSYMBOL_IF = 5,                         /* IF  */
  YYSYMBOL_ELSIF = 6,                      /* ELSIF  */
  YYSYMBOL_ELSE = 7,                       /* ELSE  */
  YYSYMBOL_REQUIRE = 8,                    /* REQUIRE  */
  YYSYMBOL_STOP = 9,                       /* STOP  */
  YYSYMBOL_DISCARD = 10,                   /* DISCARD  */
  YYSYMBOL_KEEP = 11,                      /* KEEP  */
  YYSYMBOL_FILEINTO = 12,                  /* FILEINTO  */
  YYSYMBOL_REDIRECT = 13,                  /* REDIRECT  */
  YYSYMBOL_ANYOF = 14,                     /* ANYOF  */
  YYSYMBOL_ALLOF = 15,                     /* ALLOF  */
  YYSYMBOL_EXISTS = 16,                    /* EXISTS  */
  YYSYMBOL_NOT = 17,                       /* NOT  */
  YYSYMBOL_SFALSE = 18,                    /* SFALSE  */
  YYSYMBOL_STRUE = 19,                     /* STRUE  */
  YYSYMBOL_SIZE = 20,                      /* SIZE  */
  YYSYMBOL_HEADERT = 21,                   /* HEADERT  */
  YYSYMBOL_ADDRESS = 22,                   /* ADDRESS  */
  YYSYMBOL_ENVELOPE = 23,                  /* ENVELOPE  */
  YYSYMBOL_COMPARATOR = 24,                /* COMPARATOR  */
  YYSYMBOL_OVER = 25,                      /* OVER  */
  YYSYMBOL_UNDER = 26,                     /* UNDER  */
  YYSYMBOL_ALL = 27,                       /* ALL  */
  YYSYMBOL_LOCALPART = 28,                 /* LOCALPART  */
  YYSYMBOL_DOMAIN = 29,                    /* DOMAIN  */
  YYSYMBOL_IS = 30,                        /* IS  */
  YYSYMBOL_CONTAINS = 31,                  /* CONTAINS  */
  YYSYMBOL_MATCHES = 32,                   /* MATCHES  */
  YYSYMBOL_OCTET = 33,                     /* OCTET  */
  YYSYMBOL_ASCIICASEMAP = 34,              /* ASCIICASEMAP  */
  YYSYMBOL_ASCIINUMERIC = 35,              /* ASCIINUMERIC  */
  YYSYMBOL_REGEX = 36,                     /* REGEX  */
  YYSYMBOL_QUOTEREGEX = 37,                /* QUOTEREGEX  */
  YYSYMBOL_COPY = 38,                      /* COPY  */
  YYSYMBOL_BODY = 39,                      /* BODY  */
  YYSYMBOL_RAW = 40,                       /* RAW  */
  YYSYMBOL_TEXT = 41,                      /* TEXT  */
  YYSYMBOL_CONTENT = 42,                   /* CONTENT  */
  YYSYMBOL_ENVIRONMENT = 43,               /* ENVIRONMENT  */
  YYSYMBOL_STRINGT = 44,                   /* STRINGT  */
  YYSYMBOL_SET = 45,                       /* SET  */
  YYSYMBOL_LOWER = 46,                     /* LOWER  */
  YYSYMBOL_UPPER = 47,                     /* UPPER  */
  YYSYMBOL_LOWERFIRST = 48,                /* LOWERFIRST  */
  YYSYMBOL_UPPERFIRST = 49,                /* UPPERFIRST  */
  YYSYMBOL_QUOTEWILDCARD = 50,             /* QUOTEWILDCARD  */
  YYSYMBOL_LENGTH = 51,                    /* LENGTH  */
  YYSYMBOL_VACATION = 52,                  /* VACATION  */
  YYSYMBOL_DAYS = 53,                      /* DAYS  */
  YYSYMBOL_SUBJECT = 54,                   /* SUBJECT  */
  YYSYMBOL_FROM = 55,                      /* FROM  */
  YYSYMBOL_ADDRESSES = 56,                 /* ADDRESSES  */
  YYSYMBOL_MIME = 57,                      /* MIME  */
  YYSYMBOL_HANDLE = 58,                    /* HANDLE  */
  YYSYMBOL_SECONDS = 59,                   /* SECONDS  */
  YYSYMBOL_COUNT = 60,                     /* COUNT  */
  YYSYMBOL_VALUE = 61,                     /* VALUE  */
  YYSYMBOL_GT = 62,                        /* GT  */
  YYSYMBOL_GE = 63,                        /* GE  */
  YYSYMBOL_LT = 64,                        /* LT  */
  YYSYMBOL_LE = 65,                        /* LE  */
  YYSYMBOL_EQ = 66,                        /* EQ  */
  YYSYMBOL_NE = 67,                        /* NE  */
  YYSYMBOL_FLAGS = 68,                     /* FLAGS  */
  YYSYMBOL_HASFLAG = 69,                   /* HASFLAG  */
  YYSYMBOL_SETFLAG = 70,                   /* SETFLAG  */
  YYSYMBOL_ADDFLAG = 71,                   /* ADDFLAG  */
  YYSYMBOL_REMOVEFLAG = 72,                /* REMOVEFLAG  */
  YYSYMBOL_MARK = 73,                      /* MARK  */
  YYSYMBOL_UNMARK = 74,                    /* UNMARK  */
  YYSYMBOL_USER = 75,                      /* USER  */
  YYSYMBOL_DETAIL = 76,                    /* DETAIL  */
  YYSYMBOL_DATE = 77,                      /* DATE  */
  YYSYMBOL_CURRENTDATE = 78,               /* CURRENTDATE  */
  YYSYMBOL_ORIGINALZONE = 79,              /* ORIGINALZONE  */
  YYSYMBOL_ZONE = 80,                      /* ZONE  */
  YYSYMBOL_INDEX = 81,                     /* INDEX  */
  YYSYMBOL_LAST = 82,                      /* LAST  */
  YYSYMBOL_ADDHEADER = 83,                 /* ADDHEADER  */
  YYSYMBOL_DELETEHEADER = 84,              /* DELETEHEADER  */
  YYSYMBOL_REJCT = 85,                     /* REJCT  */
  YYSYMBOL_EREJECT = 86,                   /* EREJECT  */
  YYSYMBOL_METHOD = 87,                    /* METHOD  */
  YYSYMBOL_OPTIONS = 88,                   /* OPTIONS  */
  YYSYMBOL_MESSAGE = 89,                   /* MESSAGE  */
  YYSYMBOL_IMPORTANCE = 90,                /* IMPORTANCE  */
  YYSYMBOL_VALIDNOTIFYMETHOD = 91,         /* VALIDNOTIFYMETHOD  */
  YYSYMBOL_NOTIFYMETHODCAPABILITY = 92,    /* NOTIFYMETHODCAPABILITY  */
  YYSYMBOL_NOTIFY = 93,                    /* NOTIFY  */
  YYSYMBOL_ENOTIFY = 94,                   /* ENOTIFY  */
  YYSYMBOL_ENCODEURL = 95,                 /* ENCODEURL  */
  YYSYMBOL_DENOTIFY = 96,                  /* DENOTIFY  */
  YYSYMBOL_NID = 97,                       /* NID  */
  YYSYMBOL_ANY = 98,                       /* ANY  */
  YYSYMBOL_LOW = 99,                       /* LOW  */
  YYSYMBOL_NORMAL = 100,                   /* NORMAL  */
  YYSYMBOL_HIGH = 101,                     /* HIGH  */
  YYSYMBOL_IHAVE = 102,                    /* IHAVE  */
  YYSYMBOL_ERROR = 103,                    /* ERROR  */
  YYSYMBOL_MAILBOXEXISTS = 104,            /* MAILBOXEXISTS  */
  YYSYMBOL_CREATE = 105,                   /* CREATE  */
  YYSYMBOL_METADATA = 106,                 /* METADATA  */
  YYSYMBOL_METADATAEXISTS = 107,           /* METADATAEXISTS  */
  YYSYMBOL_SERVERMETADATA = 108,           /* SERVERMETADATA  */
  YYSYMBOL_SERVERMETADATAEXISTS = 109,     /* SERVERMETADATAEXISTS  */
  YYSYMBOL_BYTIMEREL = 110,                /* BYTIMEREL  */
  YYSYMBOL_BYTIMEABS = 111,                /* BYTIMEABS  */
  YYSYMBOL_BYMODE = 112,                   /* BYMODE  */
  YYSYMBOL_BYTRACE = 113,                  /* BYTRACE  */
  YYSYMBOL_DSNNOTIFY = 114,                /* DSNNOTIFY  */
  YYSYMBOL_DSNRET = 115,                   /* DSNRET  */
  YYSYMBOL_VALIDEXTLIST = 116,             /* VALIDEXTLIST  */
  YYSYMBOL_LIST = 117,                     /* LIST  */
  YYSYMBOL_INCLUDE = 118,                  /* INCLUDE  */
  YYSYMBOL_OPTIONAL = 119,                 /* OPTIONAL  */
  YYSYMBOL_ONCE = 120,                     /* ONCE  */
  YYSYMBOL_RETURN = 121,                   /* RETURN  */
  YYSYMBOL_PERSONAL = 122,                 /* PERSONAL  */
  YYSYMBOL_GLOBAL = 123,                   /* GLOBAL  */
  YYSYMBOL_DUPLICATE = 124,                /* DUPLICATE  */
  YYSYMBOL_HEADER = 125,                   /* HEADER  */
  YYSYMBOL_UNIQUEID = 126,                 /* UNIQUEID  */
  YYSYMBOL_SPECIALUSEEXISTS = 127,         /* SPECIALUSEEXISTS  */
  YYSYMBOL_SPECIALUSE = 128,               /* SPECIALUSE  */
  YYSYMBOL_FCC = 129,                      /* FCC  */
  YYSYMBOL_MAILBOXID = 130,                /* MAILBOXID  */
  YYSYMBOL_MAILBOXIDEXISTS = 131,          /* MAILBOXIDEXISTS  */
  YYSYMBOL_SNOOZE = 132,                   /* SNOOZE  */
  YYSYMBOL_MAILBOX = 133,                  /* MAILBOX  */
  YYSYMBOL_ADDFLAGS = 134,                 /* ADDFLAGS  */
  YYSYMBOL_REMOVEFLAGS = 135,              /* REMOVEFLAGS  */
  YYSYMBOL_WEEKDAYS = 136,                 /* WEEKDAYS  */
  YYSYMBOL_TZID = 137,                     /* TZID  */
  YYSYMBOL_LOG = 138,                      /* LOG  */
  YYSYMBOL_JMAPQUERY = 139,                /* JMAPQUERY  */
  YYSYMBOL_PROCESSIMIP = 140,              /* PROCESSIMIP  */
  YYSYMBOL_INVITESONLY = 141,              /* INVITESONLY  */
  YYSYMBOL_UPDATESONLY = 142,              /* UPDATESONLY  */
  YYSYMBOL_DELETECANCELED = 143,           /* DELETECANCELED  */
  YYSYMBOL_CALENDARID = 144,               /* CALENDARID  */
  YYSYMBOL_OUTCOME = 145,                  /* OUTCOME  */
  YYSYMBOL_ERRSTR = 146,                   /* ERRSTR  */
  YYSYMBOL_147_ = 147,                     /* ';'  */
  YYSYMBOL_148_ = 148,                     /* '['  */
  YYSYMBOL_149_ = 149,                     /* ']'  */
  YYSYMBOL_150_ = 150,                     /* ','  */
  YYSYMBOL_151_ = 151,                     /* '{'  */
  YYSYMBOL_152_ = 152,                     /* '}'  */
  YYSYMBOL_153_ = 153,                     /* '('  */
  YYSYMBOL_154_ = 154,                     /* ')'  */
  YYSYMBOL_YYACCEPT = 155,                 /* $accept  */
  YYSYMBOL_start = 156,                    /* start  */
  YYSYMBOL_reqs = 157,                     /* reqs  */
  YYSYMBOL_commands = 158,                 /* commands  */
  YYSYMBOL_command = 159,                  /* command  */
  YYSYMBOL_optstringlist = 160,            /* optstringlist  */
  YYSYMBOL_stringlist = 161,               /* stringlist  */
  YYSYMBOL_strings = 162,                  /* strings  */
  YYSYMBOL_string1 = 163,                  /* string1  */
  YYSYMBOL_string = 164,                   /* string  */
  YYSYMBOL_require = 165,                  /* require  */
  YYSYMBOL_control = 166,                  /* control  */
  YYSYMBOL_thenelse = 167,                 /* thenelse  */
  YYSYMBOL_elsif = 168,                    /* elsif  */
  YYSYMBOL_block = 169,                    /* block  */
  YYSYMBOL_itags = 170,                    /* itags  */
  YYSYMBOL_location = 171,                 /* location  */
  YYSYMBOL_action = 172,                   /* action  */
  YYSYMBOL_ktags = 173,                    /* ktags  */
  YYSYMBOL_flags = 174,                    /* flags  */
  YYSYMBOL_ftags = 175,                    /* ftags  */
  YYSYMBOL_copy = 176,                     /* copy  */
  YYSYMBOL_create = 177,                   /* create  */
  YYSYMBOL_specialuse = 178,               /* specialuse  */
  YYSYMBOL_mailboxid = 179,                /* mailboxid  */
  YYSYMBOL_rtags = 180,                    /* rtags  */
  YYSYMBOL_delbytags = 181,                /* delbytags  */
  YYSYMBOL_dsntags = 182,                  /* dsntags  */
  YYSYMBOL_stags = 183,                    /* stags  */
  YYSYMBOL_mod40 = 184,                    /* mod40  */
  YYSYMBOL_mod30 = 185,                    /* mod30  */
  YYSYMBOL_mod20 = 186,                    /* mod20  */
  YYSYMBOL_mod15 = 187,                    /* mod15  */
  YYSYMBOL_mod10 = 188,                    /* mod10  */
  YYSYMBOL_vtags = 189,                    /* vtags  */
  YYSYMBOL_fcctags = 190,                  /* fcctags  */
  YYSYMBOL_flagaction = 191,               /* flagaction  */
  YYSYMBOL_flagtags = 192,                 /* flagtags  */
  YYSYMBOL_flagmark = 193,                 /* flagmark  */
  YYSYMBOL_ahtags = 194,                   /* ahtags  */
  YYSYMBOL_dhtags = 195,                   /* dhtags  */
  YYSYMBOL_reject = 196,                   /* reject  */
  YYSYMBOL_ntags = 197,                    /* ntags  */
  YYSYMBOL_priority = 198,                 /* priority  */
  YYSYMBOL_dtags = 199,                    /* dtags  */
  YYSYMBOL_sntags = 200,                   /* sntags  */
  YYSYMBOL_weekdaylist = 201,              /* weekdaylist  */
  YYSYMBOL_weekdays = 202,                 /* weekdays  */
  YYSYMBOL_weekday = 203,                  /* weekday  */
  YYSYMBOL_timelist = 204,                 /* timelist  */
  YYSYMBOL_times = 205,                    /* times  */
  YYSYMBOL_time1 = 206,                    /* time1  */
  YYSYMBOL_time = 207,                     /* time  */
  YYSYMBOL_imiptags = 208,                 /* imiptags  */
  YYSYMBOL_testlist = 209,                 /* testlist  */
  YYSYMBOL_tests = 210,                    /* tests  */
  YYSYMBOL_test = 211,                     /* test  */
  YYSYMBOL_212_1 = 212,                    /* $@1  */
  YYSYMBOL_213_2 = 213,                    /* $@2  */
  YYSYMBOL_sizetag = 214,                  /* sizetag  */
  YYSYMBOL_htags = 215,                    /* htags  */
  YYSYMBOL_matchtype = 216,                /* matchtype  */
  YYSYMBOL_matchtag = 217,                 /* matchtag  */
  YYSYMBOL_relmatch = 218,                 /* relmatch  */
  YYSYMBOL_relation = 219,                 /* relation  */
  YYSYMBOL_listmatch = 220,                /* listmatch  */
  YYSYMBOL_comparator = 221,               /* comparator  */
  YYSYMBOL_collation = 222,                /* collation  */
  YYSYMBOL_indexext = 223,                 /* indexext  */
  YYSYMBOL_index = 224,                    /* index  */
  YYSYMBOL_atags = 225,                    /* atags  */
  YYSYMBOL_addrpart = 226,                 /* addrpart  */
  YYSYMBOL_addrparttag = 227,              /* addrparttag  */
  YYSYMBOL_subaddress = 228,               /* subaddress  */
  YYSYMBOL_etags = 229,                    /* etags  */
  YYSYMBOL_envtags = 230,                  /* envtags  */
  YYSYMBOL_btags = 231,                    /* btags  */
  YYSYMBOL_transform = 232,                /* transform  */
  YYSYMBOL_strtags = 233,                  /* strtags  */
  YYSYMBOL_hftags = 234,                   /* hftags  */
  YYSYMBOL_dttags = 235,                   /* dttags  */
  YYSYMBOL_zone = 236,                     /* zone  */
  YYSYMBOL_cdtags = 237,                   /* cdtags  */
  YYSYMBOL_methtags = 238,                 /* methtags  */
  YYSYMBOL_mtags = 239,                    /* mtags  */
  YYSYMBOL_duptags = 240,                  /* duptags  */
  YYSYMBOL_idtype = 241                    /* idtype  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  10
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   771

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  155
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  87
/* YYNRULES -- Number of rules.  */
#define YYNRULES  288
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  411

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   401


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     153,   154,     2,     2,   150,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   147,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   148,     2,   149,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   151,     2,   152,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   368,   368,   369,   373,   374,   379,   380,   384,   385,
     386,   398,   399,   403,   404,   408,   409,   413,   420,   427,
     431,   432,   433,   434,   436,   440,   451,   452,   453,   457,
     458,   463,   464,   473,   482,   495,   496,   503,   504,   505,
     506,   507,   509,   512,   516,   521,   524,   528,   529,   532,
     535,   536,   537,   538,   543,   547,   552,   572,   580,   581,
     582,   583,   584,   589,   606,   623,   648,   674,   678,   679,
     691,   698,   708,   730,   750,   762,   778,   790,   806,   807,
     816,   825,   834,   843,   856,   857,   860,   861,   864,   865,
     877,   888,   893,   901,   910,   924,   934,   945,   956,   965,
     975,   979,   995,   996,   997,   998,  1003,  1004,  1005,  1010,
    1011,  1030,  1031,  1036,  1037,  1050,  1054,  1055,  1056,  1057,
    1062,  1063,  1074,  1084,  1095,  1105,  1108,  1118,  1128,  1139,
    1150,  1165,  1166,  1167,  1172,  1176,  1186,  1195,  1201,  1211,
    1212,  1213,  1215,  1231,  1247,  1257,  1270,  1271,  1275,  1276,
    1280,  1284,  1285,  1289,  1290,  1294,  1301,  1306,  1307,  1329,
    1351,  1367,  1384,  1400,  1421,  1425,  1426,  1430,  1431,  1432,
    1433,  1434,  1435,  1441,  1450,  1453,  1455,  1458,  1460,  1464,
    1471,  1473,  1476,  1479,  1482,  1489,  1493,  1495,  1502,  1502,
    1506,  1513,  1513,  1517,  1525,  1532,  1534,  1541,  1548,  1555,
    1560,  1565,  1566,  1571,  1575,  1576,  1577,  1578,  1583,  1593,
    1615,  1616,  1617,  1618,  1631,  1632,  1637,  1638,  1639,  1640,
    1641,  1642,  1647,  1667,  1682,  1683,  1684,  1698,  1709,  1724,
    1743,  1747,  1748,  1749,  1750,  1751,  1756,  1771,  1772,  1773,
    1774,  1785,  1786,  1791,  1795,  1796,  1797,  1798,  1803,  1807,
    1808,  1813,  1817,  1827,  1840,  1841,  1846,  1847,  1852,  1856,
    1857,  1858,  1863,  1867,  1868,  1873,  1877,  1878,  1887,  1888,
    1889,  1894,  1911,  1915,  1916,  1917,  1922,  1927,  1928,  1933,
    1938,  1939,  1944,  1945,  1956,  1966,  1975,  1988,  1989
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "NUMBER", "STRING",
  "IF", "ELSIF", "ELSE", "REQUIRE", "STOP", "DISCARD", "KEEP", "FILEINTO",
  "REDIRECT", "ANYOF", "ALLOF", "EXISTS", "NOT", "SFALSE", "STRUE", "SIZE",
  "HEADERT", "ADDRESS", "ENVELOPE", "COMPARATOR", "OVER", "UNDER", "ALL",
  "LOCALPART", "DOMAIN", "IS", "CONTAINS", "MATCHES", "OCTET",
  "ASCIICASEMAP", "ASCIINUMERIC", "REGEX", "QUOTEREGEX", "COPY", "BODY",
  "RAW", "TEXT", "CONTENT", "ENVIRONMENT", "STRINGT", "SET", "LOWER",
  "UPPER", "LOWERFIRST", "UPPERFIRST", "QUOTEWILDCARD", "LENGTH",
  "VACATION", "DAYS", "SUBJECT", "FROM", "ADDRESSES", "MIME", "HANDLE",
  "SECONDS", "COUNT", "VALUE", "GT", "GE", "LT", "LE", "EQ", "NE", "FLAGS",
  "HASFLAG", "SETFLAG", "ADDFLAG", "REMOVEFLAG", "MARK", "UNMARK", "USER",
  "DETAIL", "DATE", "CURRENTDATE", "ORIGINALZONE", "ZONE", "INDEX", "LAST",
  "ADDHEADER", "DELETEHEADER", "REJCT", "EREJECT", "METHOD", "OPTIONS",
  "MESSAGE", "IMPORTANCE", "VALIDNOTIFYMETHOD", "NOTIFYMETHODCAPABILITY",
  "NOTIFY", "ENOTIFY", "ENCODEURL", "DENOTIFY", "NID", "ANY", "LOW",
  "NORMAL", "HIGH", "IHAVE", "ERROR", "MAILBOXEXISTS", "CREATE",
  "METADATA", "METADATAEXISTS", "SERVERMETADATA", "SERVERMETADATAEXISTS",
  "BYTIMEREL", "BYTIMEABS", "BYMODE", "BYTRACE", "DSNNOTIFY", "DSNRET",
  "VALIDEXTLIST", "LIST", "INCLUDE", "OPTIONAL", "ONCE", "RETURN",
  "PERSONAL", "GLOBAL", "DUPLICATE", "HEADER", "UNIQUEID",
  "SPECIALUSEEXISTS", "SPECIALUSE", "FCC", "MAILBOXID", "MAILBOXIDEXISTS",
  "SNOOZE", "MAILBOX", "ADDFLAGS", "REMOVEFLAGS", "WEEKDAYS", "TZID",
  "LOG", "JMAPQUERY", "PROCESSIMIP", "INVITESONLY", "UPDATESONLY",
  "DELETECANCELED", "CALENDARID", "OUTCOME", "ERRSTR", "';'", "'['", "']'",
  "','", "'{'", "'}'", "'('", "')'", "$accept", "start", "reqs",
  "commands", "command", "optstringlist", "stringlist", "strings",
  "string1", "string", "require", "control", "thenelse", "elsif", "block",
  "itags", "location", "action", "ktags", "flags", "ftags", "copy",
  "create", "specialuse", "mailboxid", "rtags", "delbytags", "dsntags",
  "stags", "mod40", "mod30", "mod20", "mod15", "mod10", "vtags", "fcctags",
  "flagaction", "flagtags", "flagmark", "ahtags", "dhtags", "reject",
  "ntags", "priority", "dtags", "sntags", "weekdaylist", "weekdays",
  "weekday", "timelist", "times", "time1", "time", "imiptags", "testlist",
  "tests", "test", "$@1", "$@2", "sizetag", "htags", "matchtype",
  "matchtag", "relmatch", "relation", "listmatch", "comparator",
  "collation", "indexext", "index", "atags", "addrpart", "addrparttag",
  "subaddress", "etags", "envtags", "btags", "transform", "strtags",
  "hftags", "dttags", "zone", "cdtags", "methtags", "mtags", "duptags",
  "idtype", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-358)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-18)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
       7,     2,    20,   495,     7,  -358,    31,  -122,  -358,  -358,
    -358,  -108,   515,  -101,  -358,  -358,  -358,  -358,  -358,  -358,
    -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,
    -358,    31,  -358,   -98,  -358,    31,  -358,  -358,    21,  -358,
     -96,  -358,  -358,    31,  -358,  -139,  -358,  -358,  -358,  -358,
     -93,   -93,     2,   515,  -358,  -358,    18,  -358,  -358,  -358,
    -358,  -358,  -358,  -358,  -358,  -358,     2,  -358,     2,     2,
    -358,    31,  -358,     2,     2,  -358,     2,     2,    31,  -358,
     -86,  -358,     4,    10,   223,   263,   604,     1,   643,   422,
     646,   -58,    63,  -358,    -3,  -358,   321,  -358,  -358,     2,
    -358,  -358,    31,   515,  -358,  -358,  -358,  -358,  -358,  -358,
      74,   343,   205,   222,   391,   457,   160,   414,   660,   540,
    -358,   457,  -358,  -358,  -358,     2,  -358,  -358,  -358,   -40,
    -358,     2,  -358,  -358,   316,    73,     2,  -358,  -358,  -358,
      31,    31,  -358,  -358,  -358,  -358,  -358,  -358,    96,    31,
      31,  -358,    31,    31,  -358,  -358,  -358,  -358,  -358,  -358,
    -358,  -358,  -358,  -358,  -358,  -358,  -358,    31,  -358,  -358,
    -358,  -358,  -358,    97,    31,    31,     2,  -358,    31,    98,
      31,  -358,  -358,  -358,  -358,  -358,  -358,  -358,    31,    29,
    -358,  -358,  -358,  -358,  -358,  -358,   100,  -358,  -358,     2,
    -358,  -358,   586,  -358,  -358,  -358,    31,    31,     2,    31,
     -25,    31,  -358,  -358,  -358,  -358,  -358,  -358,  -358,    31,
    -358,  -358,  -358,  -358,  -358,   -39,  -358,  -358,    31,     2,
       2,     3,    31,   107,  -358,  -358,  -358,  -358,  -358,  -358,
    -358,  -358,  -358,    31,    31,    31,  -358,   -35,  -358,   -41,
     -34,  -358,     2,  -358,  -358,  -358,  -358,  -358,  -358,  -358,
    -358,  -358,  -358,     2,  -358,  -358,  -358,  -358,  -358,  -358,
    -358,     2,  -358,  -358,  -358,  -358,  -358,  -358,     2,  -358,
    -358,  -358,  -358,     2,  -358,  -358,     2,  -358,  -358,  -358,
       2,  -358,  -358,  -358,    31,    31,  -358,  -358,  -358,  -358,
       2,  -358,  -358,  -358,    31,  -358,  -358,   457,  -358,   457,
      31,   117,  -358,  -358,  -358,    31,  -358,  -358,   -26,   515,
     -86,  -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,
    -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,
    -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,
    -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,
    -358,  -358,  -358,  -358,  -358,   124,  -358,  -358,  -358,   -80,
    -358,  -358,  -358,  -358,  -358,   515,  -358,  -358,  -358,  -358,
    -358,  -358,  -358,  -358,     2,  -358,     2,    31,  -358,  -358,
       2,  -358,  -358,  -358,  -358,  -358,  -358,   -68,  -358,  -358,
     107,  -358,  -358,  -358,     2,  -358,  -358,   124,  -358,  -358,
    -358
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       4,     0,     0,     0,     4,    18,     0,     0,    13,    17,
       1,     0,     0,     0,    40,    54,    57,    67,    78,    92,
     106,   107,   108,   111,   112,   113,   115,   120,   121,   122,
     134,     0,    31,     0,   137,     0,   157,     3,     0,     8,
       0,   109,    44,     0,     5,     0,    15,    19,    10,   200,
       0,     0,     0,     0,   170,   171,     0,   203,   230,   243,
     251,   248,   258,   262,   265,   272,     0,   276,     0,     0,
     188,     0,   191,     0,     0,   282,     0,     0,     0,    20,
       0,    21,    37,     0,     0,     0,     0,     0,     0,    49,
      50,     0,     0,    24,     0,    51,    53,     7,     9,     0,
      47,    14,     0,     0,   167,   168,   172,   169,   201,   202,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     184,     0,   186,   187,   279,     0,   279,   193,   194,   195,
     196,    17,   198,   199,     0,    26,     0,    55,    63,    64,
       0,     0,    38,    59,    58,    60,    61,    62,     0,     0,
       0,    75,     0,     0,    69,    39,    68,    70,    71,    89,
      84,    85,    86,    87,    88,    91,    90,     0,    79,    80,
      81,    82,    83,     0,     0,     0,     0,    98,     0,     0,
       0,    42,   103,   102,   104,   105,   100,   114,     0,     0,
     210,   211,   212,   213,   214,   215,     0,   229,   222,    11,
     116,   208,     0,   117,   118,   119,     0,     0,     0,     0,
       0,     0,   131,   132,   133,    48,   125,   128,   135,     0,
      22,    34,    33,    35,    36,     0,    32,   156,     0,     0,
       0,     0,     0,     0,   139,   140,   141,    52,   151,   155,
     158,   159,   160,     0,     0,     0,    43,   110,    16,     0,
     165,   173,     0,   204,   205,   206,   207,   227,   237,   238,
     239,   241,   242,     0,   232,   233,   234,   235,   231,   236,
     240,     0,   245,   246,   247,   244,   256,   257,     0,   177,
     254,   255,   252,     0,   249,   250,     0,   259,   260,   261,
     181,   263,   264,   267,     0,     0,   268,   269,   270,   266,
       0,   274,   275,   273,     0,   277,   278,     0,   190,     0,
       0,     0,   286,   287,   288,     0,   197,    30,     0,     0,
       0,    25,    56,    65,    66,    72,    73,    74,    76,    77,
      41,    93,    95,    96,    97,    99,    94,   101,    45,   224,
     225,   226,   223,   228,    46,    12,   218,   219,   220,   221,
     216,   217,   209,   123,   127,   130,   129,   124,   126,   136,
      23,   138,   142,   143,   150,     0,   144,   146,   145,     0,
     153,   161,   162,   163,   164,     0,   174,   175,   176,   253,
     178,   179,   180,   271,     0,   183,     0,     0,   280,   281,
       0,   284,   285,   283,    29,    27,    28,     0,   148,   152,
       0,   166,   182,   185,     0,   192,   147,     0,   154,   189,
     149
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -358,  -358,   125,   -36,  -358,  -358,    94,  -358,   129,   -31,
    -358,  -358,  -182,  -358,  -179,  -358,  -358,  -358,  -358,    14,
    -358,    64,   -70,   -67,   -66,  -358,  -358,  -358,  -358,  -358,
    -358,  -358,  -358,  -358,  -358,    65,  -358,  -358,  -358,  -358,
    -358,  -358,  -358,   -87,  -358,  -358,  -358,  -358,  -357,  -358,
    -358,   -81,  -245,  -358,   105,  -217,   -44,  -358,  -358,  -358,
    -358,   638,  -358,  -358,  -358,   -75,   650,  -358,   -89,    77,
    -358,    53,  -358,  -358,  -358,  -358,  -358,  -358,  -358,  -358,
    -358,    50,  -358,  -358,    46,  -358,  -358
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     3,    37,    38,   344,     7,    45,     8,     9,
       4,    39,    79,   321,   135,    92,   226,    40,    82,   182,
      83,   144,   183,   184,   185,    84,   157,   158,    85,   168,
     169,   170,   171,   172,    86,   186,    41,    99,    42,    87,
      88,    43,    89,   217,    90,    94,   366,   397,   367,   237,
     369,   238,   239,    96,   104,   249,    80,   124,   126,   110,
     111,   388,   201,   202,   352,   203,   389,   342,   256,   257,
     112,   268,   269,   270,   113,   115,   114,   282,   116,   117,
     118,   299,   119,   121,   307,   129,   315
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      91,   227,    97,   218,    95,     5,     5,   364,   398,   107,
     101,   102,   100,   145,     5,     1,   146,   147,   310,   311,
      10,    -6,    11,   267,   234,    47,    12,   235,   236,   298,
      13,    14,    15,    16,    17,     5,   254,   265,   273,    48,
     125,   288,   312,   108,   109,   131,    81,   133,   138,    93,
     410,    98,   142,   155,   167,   181,   188,   199,   215,   250,
     103,   225,   339,   340,   341,   134,    18,     5,   247,   399,
     400,   248,   136,    19,   212,   213,   214,   251,   136,   319,
     320,   406,   407,   187,   283,   313,   314,   295,   300,   220,
     304,    20,    21,    22,    23,    24,   137,   143,   318,   325,
     331,   336,   139,   343,    25,    26,    27,    28,   360,   323,
     324,   227,   -17,   374,    29,   139,   375,    30,   326,   327,
     392,   328,   329,   357,    31,   140,   394,   141,   364,    44,
     228,   229,   230,   231,   232,    46,   330,   395,   140,    32,
     141,   396,    33,   332,   333,   233,   106,   335,   156,   337,
       6,   365,   370,    34,   216,   408,   105,   338,   401,    35,
     120,    36,   122,   123,     5,   205,   275,   127,   128,   303,
     130,   132,   309,    -6,     0,   353,   354,     0,   356,     0,
     358,     0,   221,   222,   189,   223,   224,     0,   359,     0,
     190,   191,   192,   246,     0,     0,   193,   361,     0,     0,
       0,   368,     0,     0,     0,   252,   263,   271,   279,     5,
     286,   290,   371,   372,   373,     0,     0,     0,     0,   308,
     194,   195,     0,     0,     0,   316,     5,     5,     0,   189,
     322,     0,   258,   259,   260,   190,   191,   192,     0,     0,
       0,   193,     0,     0,     0,     0,   189,     0,     0,   258,
     259,   260,   190,   191,   192,     0,     0,     0,   193,     0,
       0,   138,     0,   383,   384,   194,   195,     5,     0,     0,
     334,     0,     0,   386,     0,     0,   387,   198,   390,   391,
     261,   262,   194,   195,   393,     0,   196,   197,     0,     0,
       0,     0,     0,   345,     0,     0,     0,   261,   262,     0,
     159,     0,   355,     0,     0,     0,     0,     0,     6,   160,
     161,   162,   163,   164,   165,     0,     0,    11,     0,     0,
       0,    12,   198,   362,   363,    13,    14,    15,    16,    17,
       0,   250,     0,   148,   149,   150,   151,   152,   153,   198,
     154,     0,     0,     0,     0,     0,   376,     5,     0,     0,
       0,     0,     0,     6,     0,     0,   404,   377,   166,     0,
       0,    18,     0,     0,     0,   378,     0,   189,    19,     0,
       6,     0,   379,   190,   191,   192,     0,   380,     0,   193,
     381,     0,     0,     0,   382,     0,    20,    21,    22,    23,
      24,     0,     0,     0,   385,     5,     0,     0,     0,    25,
      26,    27,    28,   194,   195,     0,     0,     0,     0,    29,
       0,     0,    30,     0,     0,   189,     0,     0,     5,    31,
       0,   190,   191,   192,   196,   197,     5,   193,     0,     0,
       0,   276,   277,   278,    32,     0,     0,    33,   189,     0,
       0,     0,     0,     0,   190,   191,   192,     0,    34,     0,
     193,   194,   195,     0,    35,     0,    36,     0,     0,     0,
     198,     5,   240,   241,   242,   243,   244,   245,   317,     0,
       0,     0,     0,     0,   194,   195,     0,   206,   402,     0,
     403,   189,     0,     0,   405,     0,     0,   190,   191,   192,
     136,     6,     0,   193,     0,    -2,    11,     0,   409,     0,
      12,     0,     0,     0,    13,    14,    15,    16,    17,   207,
     208,   209,   210,     0,     0,     0,    49,   194,   195,   211,
       0,   212,   213,   214,     0,     0,     0,   139,     0,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,     6,
      18,     0,     0,     0,     5,     0,     0,    19,     0,     0,
     140,   180,   141,     0,    60,     0,     0,     0,    61,    62,
       0,     0,     6,     0,   189,    20,    21,    22,    23,    24,
     190,   191,   192,     0,     0,     0,   193,     0,    25,    26,
      27,    28,     0,     0,    63,     0,     0,     0,    29,     0,
       0,    30,    64,    65,     0,     0,     0,     0,    31,     0,
     194,   195,     0,     0,     0,     0,    66,    67,     5,     0,
       0,     0,     0,    32,     0,     0,    33,    68,     0,    69,
     294,    70,    71,    72,    73,     0,     0,    34,     0,     0,
       0,    74,     0,    35,     0,    36,     0,     0,     0,    75,
       0,     0,    76,     0,     0,     0,    77,     5,   346,   347,
     348,   349,   350,   351,    78,     0,     0,   173,   174,   175,
     176,   177,   178,   179,     5,     0,     0,   189,     0,     0,
       0,     0,   136,   190,   191,   192,   190,   191,   192,   193,
       0,     0,   193,     0,   189,     0,     0,     0,     0,     0,
     190,   191,   192,     0,     0,     0,   193,     0,     0,     0,
       0,     0,     0,   194,   195,     0,   194,   195,     0,   139,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     194,   195,     0,     0,   196,   197,   200,     0,   219,     0,
       0,     0,   140,   180,   141,     0,     0,     0,   204,   293,
     294,   196,   197,     0,     0,   212,   213,   214,     0,   253,
     264,   272,   280,   284,   287,   291,   296,   301,     0,   305,
     198,   255,   266,   274,   281,   285,   289,   292,   297,   302,
       0,   306
};

static const yytype_int16 yycheck[] =
{
      31,     4,    38,    90,    35,     4,     4,     4,   365,    53,
     149,   150,    43,    83,     4,     8,    83,    83,    58,    59,
       0,     0,     1,   112,    94,   147,     5,    94,    94,   118,
       9,    10,    11,    12,    13,     4,   111,   112,   113,   147,
      71,   116,    82,    25,    26,    76,   147,    78,    38,   147,
     407,   147,    83,    84,    85,    86,    87,    88,    89,   103,
     153,    92,    33,    34,    35,   151,    45,     4,    99,   149,
     150,   102,    68,    52,    99,   100,   101,     3,    68,     6,
       7,   149,   150,    82,   115,   125,   126,   118,   119,   147,
     121,    70,    71,    72,    73,    74,    82,    83,   134,     3,
       3,     3,   105,     3,    83,    84,    85,    86,   147,   140,
     141,     4,   147,   154,    93,   105,   150,    96,   149,   150,
       3,   152,   153,   210,   103,   128,   152,   130,     4,     4,
     133,   134,   135,   136,   137,     6,   167,   319,   128,   118,
     130,   320,   121,   174,   175,   148,    52,   178,    84,   180,
     148,   148,   233,   132,    89,   400,    51,   188,   375,   138,
      66,   140,    68,    69,     4,    88,   113,    73,    74,   119,
      76,    77,   126,   152,    -1,   206,   207,    -1,   209,    -1,
     211,    -1,   119,   120,    24,   122,   123,    -1,   219,    -1,
      30,    31,    32,    99,    -1,    -1,    36,   228,    -1,    -1,
      -1,   232,    -1,    -1,    -1,   111,   112,   113,   114,     4,
     116,   117,   243,   244,   245,    -1,    -1,    -1,    -1,   125,
      60,    61,    -1,    -1,    -1,   131,     4,     4,    -1,    24,
     136,    -1,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    24,    -1,    -1,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    36,    -1,
      -1,    38,    -1,   294,   295,    60,    61,     4,    -1,    -1,
     176,    -1,    -1,   304,    -1,    -1,   307,   117,   309,   310,
      75,    76,    60,    61,   315,    -1,    81,    82,    -1,    -1,
      -1,    -1,    -1,   199,    -1,    -1,    -1,    75,    76,    -1,
      37,    -1,   208,    -1,    -1,    -1,    -1,    -1,   148,    46,
      47,    48,    49,    50,    51,    -1,    -1,     1,    -1,    -1,
      -1,     5,   117,   229,   230,     9,    10,    11,    12,    13,
      -1,   375,    -1,   110,   111,   112,   113,   114,   115,   117,
     117,    -1,    -1,    -1,    -1,    -1,   252,     4,    -1,    -1,
      -1,    -1,    -1,   148,    -1,    -1,   387,   263,    95,    -1,
      -1,    45,    -1,    -1,    -1,   271,    -1,    24,    52,    -1,
     148,    -1,   278,    30,    31,    32,    -1,   283,    -1,    36,
     286,    -1,    -1,    -1,   290,    -1,    70,    71,    72,    73,
      74,    -1,    -1,    -1,   300,     4,    -1,    -1,    -1,    83,
      84,    85,    86,    60,    61,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    96,    -1,    -1,    24,    -1,    -1,     4,   103,
      -1,    30,    31,    32,    81,    82,     4,    36,    -1,    -1,
      -1,    40,    41,    42,   118,    -1,    -1,   121,    24,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    -1,   132,    -1,
      36,    60,    61,    -1,   138,    -1,   140,    -1,    -1,    -1,
     117,     4,   141,   142,   143,   144,   145,   146,   152,    -1,
      -1,    -1,    -1,    -1,    60,    61,    -1,    55,   384,    -1,
     386,    24,    -1,    -1,   390,    -1,    -1,    30,    31,    32,
      68,   148,    -1,    36,    -1,     0,     1,    -1,   404,    -1,
       5,    -1,    -1,    -1,     9,    10,    11,    12,    13,    87,
      88,    89,    90,    -1,    -1,    -1,     1,    60,    61,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,   148,
      45,    -1,    -1,    -1,     4,    -1,    -1,    52,    -1,    -1,
     128,   129,   130,    -1,    39,    -1,    -1,    -1,    43,    44,
      -1,    -1,   148,    -1,    24,    70,    71,    72,    73,    74,
      30,    31,    32,    -1,    -1,    -1,    36,    -1,    83,    84,
      85,    86,    -1,    -1,    69,    -1,    -1,    -1,    93,    -1,
      -1,    96,    77,    78,    -1,    -1,    -1,    -1,   103,    -1,
      60,    61,    -1,    -1,    -1,    -1,    91,    92,     4,    -1,
      -1,    -1,    -1,   118,    -1,    -1,   121,   102,    -1,   104,
      80,   106,   107,   108,   109,    -1,    -1,   132,    -1,    -1,
      -1,   116,    -1,   138,    -1,   140,    -1,    -1,    -1,   124,
      -1,    -1,   127,    -1,    -1,    -1,   131,     4,    62,    63,
      64,    65,    66,    67,   139,    -1,    -1,    53,    54,    55,
      56,    57,    58,    59,     4,    -1,    -1,    24,    -1,    -1,
      -1,    -1,    68,    30,    31,    32,    30,    31,    32,    36,
      -1,    -1,    36,    -1,    24,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    60,    61,    -1,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    81,    82,    88,    -1,    90,    -1,
      -1,    -1,   128,   129,   130,    -1,    -1,    -1,    88,    79,
      80,    81,    82,    -1,    -1,    99,   100,   101,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     117,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     8,   156,   157,   165,     4,   148,   161,   163,   164,
       0,     1,     5,     9,    10,    11,    12,    13,    45,    52,
      70,    71,    72,    73,    74,    83,    84,    85,    86,    93,
      96,   103,   118,   121,   132,   138,   140,   158,   159,   166,
     172,   191,   193,   196,   157,   162,   163,   147,   147,     1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      39,    43,    44,    69,    77,    78,    91,    92,   102,   104,
     106,   107,   108,   109,   116,   124,   127,   131,   139,   167,
     211,   147,   173,   175,   180,   183,   189,   194,   195,   197,
     199,   164,   170,   147,   200,   164,   208,   158,   147,   192,
     164,   149,   150,   153,   209,   209,   161,   211,    25,    26,
     214,   215,   225,   229,   231,   230,   233,   234,   235,   237,
     161,   238,   161,   161,   212,   164,   213,   161,   161,   240,
     161,   164,   161,   164,   151,   169,    68,   174,    38,   105,
     128,   130,   164,   174,   176,   177,   178,   179,   110,   111,
     112,   113,   114,   115,   117,   164,   176,   181,   182,    37,
      46,    47,    48,    49,    50,    51,    95,   164,   184,   185,
     186,   187,   188,    53,    54,    55,    56,    57,    58,    59,
     129,   164,   174,   177,   178,   179,   190,    82,   164,    24,
      30,    31,    32,    36,    60,    61,    81,    82,   117,   164,
     216,   217,   218,   220,   221,   224,    55,    87,    88,    89,
      90,    97,    99,   100,   101,   164,   190,   198,   198,   216,
     147,   119,   120,   122,   123,   164,   171,     4,   133,   134,
     135,   136,   137,   148,   177,   178,   179,   204,   206,   207,
     141,   142,   143,   144,   145,   146,   161,   164,   164,   210,
     211,     3,   161,   216,   220,   221,   223,   224,    27,    28,
      29,    75,    76,   161,   216,   220,   221,   223,   226,   227,
     228,   161,   216,   220,   221,   226,    40,    41,    42,   161,
     216,   221,   232,   164,   216,   221,   161,   216,   220,   221,
     161,   216,   221,    79,    80,   164,   216,   221,   223,   236,
     164,   216,   221,   236,   164,   216,   221,   239,   161,   239,
      58,    59,    82,   125,   126,   241,   161,   152,   158,     6,
       7,   168,   161,   164,   164,     3,   164,   164,   164,   164,
     164,     3,   164,   164,   161,   164,     3,   164,   164,    33,
      34,    35,   222,     3,   160,   161,    62,    63,    64,    65,
      66,    67,   219,   164,   164,   161,   164,   198,   164,   164,
     147,   164,   161,   161,     4,   148,   201,   203,   164,   205,
     206,   164,   164,   164,   154,   150,   161,   161,   161,   161,
     161,   161,   161,   164,   164,   161,   164,   164,   216,   221,
     164,   164,     3,   164,   152,   167,   169,   202,   203,   149,
     150,   210,   161,   161,   164,   161,   149,   150,   207,   161,
     203
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   155,   156,   156,   157,   157,   158,   158,   159,   159,
     159,   160,   160,   161,   161,   162,   162,   163,   164,   165,
     166,   166,   166,   166,   166,   167,   168,   168,   168,   169,
     169,   170,   170,   170,   170,   171,   171,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   173,   173,   174,   175,   175,   175,
     175,   175,   175,   176,   177,   178,   179,   180,   180,   180,
     180,   180,   181,   181,   181,   181,   182,   182,   183,   183,
     183,   183,   183,   183,   184,   184,   185,   185,   186,   186,
     187,   188,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   190,   190,   190,   190,   190,   191,   191,   191,   192,
     192,   193,   193,   194,   194,   195,   195,   195,   195,   195,
     196,   196,   197,   197,   197,   197,   197,   197,   197,   197,
     197,   198,   198,   198,   199,   199,   199,   200,   200,   200,
     200,   200,   200,   200,   200,   200,   201,   201,   202,   202,
     203,   204,   204,   205,   205,   206,   207,   208,   208,   208,
     208,   208,   208,   208,   209,   210,   210,   211,   211,   211,
     211,   211,   211,   211,   211,   211,   211,   211,   211,   211,
     211,   211,   211,   211,   211,   211,   211,   211,   212,   211,
     211,   213,   211,   211,   211,   211,   211,   211,   211,   211,
     211,   214,   214,   215,   215,   215,   215,   215,   216,   216,
     217,   217,   217,   217,   218,   218,   219,   219,   219,   219,
     219,   219,   220,   221,   222,   222,   222,   223,   224,   224,
     225,   225,   225,   225,   225,   225,   226,   227,   227,   227,
     227,   228,   228,   229,   229,   229,   229,   229,   230,   230,
     230,   231,   231,   231,   231,   231,   232,   232,   233,   233,
     233,   233,   234,   234,   234,   235,   235,   235,   235,   235,
     235,   236,   237,   237,   237,   237,   238,   238,   238,   239,
     239,   239,   240,   240,   240,   240,   240,   241,   241
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     0,     2,     1,     2,     1,     2,
       2,     0,     1,     1,     3,     1,     3,     1,     1,     3,
       2,     2,     3,     4,     2,     3,     0,     2,     2,     3,
       2,     0,     2,     2,     2,     1,     1,     2,     3,     3,
       1,     4,     3,     3,     1,     4,     4,     2,     3,     2,
       2,     2,     3,     2,     0,     2,     2,     0,     2,     2,
       2,     2,     2,     1,     1,     2,     2,     0,     2,     2,
       2,     2,     2,     2,     2,     1,     2,     2,     0,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     3,     3,     3,     3,     3,     2,     3,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     1,     1,     0,     2,     0,     2,     2,     2,     2,
       1,     1,     0,     3,     3,     2,     3,     3,     2,     3,
       3,     1,     1,     1,     0,     2,     3,     0,     3,     2,
       2,     2,     3,     3,     3,     3,     1,     3,     1,     3,
       1,     1,     3,     1,     3,     1,     1,     0,     2,     2,
       2,     3,     3,     3,     3,     1,     3,     2,     2,     2,
       1,     1,     2,     3,     4,     4,     4,     3,     4,     4,
       4,     3,     5,     4,     2,     5,     2,     2,     0,     6,
       3,     0,     5,     2,     2,     2,     2,     3,     2,     2,
       1,     1,     1,     0,     2,     2,     2,     2,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     2,     1,
       0,     2,     2,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     0,     2,     2,     2,     2,     0,     2,
       2,     0,     2,     3,     2,     2,     1,     1,     0,     2,
       2,     2,     0,     2,     2,     0,     2,     2,     2,     2,
       2,     2,     0,     2,     2,     2,     0,     2,     2,     0,
       2,     2,     0,     3,     3,     3,     2,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (sscript, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, sscript); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, sieve_script_t *sscript)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (sscript);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, sieve_script_t *sscript)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, sscript);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, sieve_script_t *sscript)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], sscript);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, sscript); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, sieve_script_t *sscript)
{
  YY_USE (yyvaluep);
  YY_USE (sscript);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_STRING: /* STRING  */
#line 173 "sieve/sieve.y"
             { free(((*yyvaluep).sval));          }
#line 1973 "sieve/sieve.c"
        break;

    case YYSYMBOL_commands: /* commands  */
#line 169 "sieve/sieve.y"
             { free_tree(((*yyvaluep).cl));     }
#line 1979 "sieve/sieve.c"
        break;

    case YYSYMBOL_command: /* command  */
#line 169 "sieve/sieve.y"
             { free_tree(((*yyvaluep).cl));     }
#line 1985 "sieve/sieve.c"
        break;

    case YYSYMBOL_optstringlist: /* optstringlist  */
#line 172 "sieve/sieve.y"
             { strarray_free(((*yyvaluep).sl)); }
#line 1991 "sieve/sieve.c"
        break;

    case YYSYMBOL_stringlist: /* stringlist  */
#line 172 "sieve/sieve.y"
             { strarray_free(((*yyvaluep).sl)); }
#line 1997 "sieve/sieve.c"
        break;

    case YYSYMBOL_strings: /* strings  */
#line 172 "sieve/sieve.y"
             { strarray_free(((*yyvaluep).sl)); }
#line 2003 "sieve/sieve.c"
        break;

    case YYSYMBOL_string1: /* string1  */
#line 172 "sieve/sieve.y"
             { strarray_free(((*yyvaluep).sl)); }
#line 2009 "sieve/sieve.c"
        break;

    case YYSYMBOL_string: /* string  */
#line 173 "sieve/sieve.y"
             { free(((*yyvaluep).sval));          }
#line 2015 "sieve/sieve.c"
        break;

    case YYSYMBOL_control: /* control  */
#line 169 "sieve/sieve.y"
             { free_tree(((*yyvaluep).cl));     }
#line 2021 "sieve/sieve.c"
        break;

    case YYSYMBOL_thenelse: /* thenelse  */
#line 169 "sieve/sieve.y"
             { free_tree(((*yyvaluep).cl));     }
#line 2027 "sieve/sieve.c"
        break;

    case YYSYMBOL_elsif: /* elsif  */
#line 169 "sieve/sieve.y"
             { free_tree(((*yyvaluep).cl));     }
#line 2033 "sieve/sieve.c"
        break;

    case YYSYMBOL_block: /* block  */
#line 169 "sieve/sieve.y"
             { free_tree(((*yyvaluep).cl));     }
#line 2039 "sieve/sieve.c"
        break;

    case YYSYMBOL_action: /* action  */
#line 169 "sieve/sieve.y"
             { free_tree(((*yyvaluep).cl));     }
#line 2045 "sieve/sieve.c"
        break;

    case YYSYMBOL_ftags: /* ftags  */
#line 169 "sieve/sieve.y"
             { free_tree(((*yyvaluep).cl));     }
#line 2051 "sieve/sieve.c"
        break;

    case YYSYMBOL_timelist: /* timelist  */
#line 174 "sieve/sieve.y"
             { arrayu64_free(((*yyvaluep).nl)); }
#line 2057 "sieve/sieve.c"
        break;

    case YYSYMBOL_times: /* times  */
#line 174 "sieve/sieve.y"
             { arrayu64_free(((*yyvaluep).nl)); }
#line 2063 "sieve/sieve.c"
        break;

    case YYSYMBOL_time1: /* time1  */
#line 174 "sieve/sieve.y"
             { arrayu64_free(((*yyvaluep).nl)); }
#line 2069 "sieve/sieve.c"
        break;

    case YYSYMBOL_testlist: /* testlist  */
#line 170 "sieve/sieve.y"
             { free_testlist(((*yyvaluep).testl)); }
#line 2075 "sieve/sieve.c"
        break;

    case YYSYMBOL_tests: /* tests  */
#line 170 "sieve/sieve.y"
             { free_testlist(((*yyvaluep).testl)); }
#line 2081 "sieve/sieve.c"
        break;

    case YYSYMBOL_test: /* test  */
#line 171 "sieve/sieve.y"
             { free_test(((*yyvaluep).test));     }
#line 2087 "sieve/sieve.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (sieve_script_t *sscript)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, sscript);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* start: reqs  */
#line 368 "sieve/sieve.y"
                                 { sscript->cmds = NULL; }
#line 2363 "sieve/sieve.c"
    break;

  case 3: /* start: reqs commands  */
#line 369 "sieve/sieve.y"
                                 { sscript->cmds = (yyvsp[0].cl); }
#line 2369 "sieve/sieve.c"
    break;

  case 7: /* commands: command commands  */
#line 380 "sieve/sieve.y"
                                 { (yyval.cl) = (yyvsp[-1].cl); (yyval.cl)->next = (yyvsp[0].cl); }
#line 2375 "sieve/sieve.c"
    break;

  case 10: /* command: error ';'  */
#line 386 "sieve/sieve.y"
                                 {
                                     struct buf buf = BUF_INITIALIZER;
                                     buf_printf(&buf, "%s: line %d",
                                                error_message(SIEVE_UNSUPP_EXT),
                                                sievelineno);
                                     sscript->support |= SIEVE_CAPA_IHAVE;
                                     (yyval.cl) = build_rej_err(sscript, B_ERROR,
                                                        buf_release(&buf));
                                 }
#line 2389 "sieve/sieve.c"
    break;

  case 11: /* optstringlist: %empty  */
#line 398 "sieve/sieve.y"
                                 { (yyval.sl) = strarray_new(); }
#line 2395 "sieve/sieve.c"
    break;

  case 14: /* stringlist: '[' strings ']'  */
#line 404 "sieve/sieve.y"
                                 { (yyval.sl) = (yyvsp[-1].sl); }
#line 2401 "sieve/sieve.c"
    break;

  case 16: /* strings: strings ',' string  */
#line 409 "sieve/sieve.y"
                                 { (yyval.sl) = (yyvsp[-2].sl); strarray_appendm((yyval.sl), (yyvsp[0].sval)); }
#line 2407 "sieve/sieve.c"
    break;

  case 17: /* string1: string  */
#line 413 "sieve/sieve.y"
                                 {
                                     (yyval.sl) = strarray_new();
                                     strarray_appendm((yyval.sl), (yyvsp[0].sval));
                                 }
#line 2416 "sieve/sieve.c"
    break;

  case 18: /* string: STRING  */
#line 420 "sieve/sieve.y"
                                 { (yyval.sval) = (yyvsp[0].sval); chk_match_vars(sscript, (yyval.sval)); }
#line 2422 "sieve/sieve.c"
    break;

  case 19: /* require: REQUIRE stringlist ';'  */
#line 427 "sieve/sieve.y"
                                 { check_reqs(sscript, (yyvsp[-1].sl)); }
#line 2428 "sieve/sieve.c"
    break;

  case 20: /* control: IF thenelse  */
#line 431 "sieve/sieve.y"
                                 { (yyval.cl) = (yyvsp[0].cl); }
#line 2434 "sieve/sieve.c"
    break;

  case 21: /* control: STOP ';'  */
#line 432 "sieve/sieve.y"
                                 { (yyval.cl) = new_command(B_STOP, sscript); }
#line 2440 "sieve/sieve.c"
    break;

  case 22: /* control: ERROR string ';'  */
#line 433 "sieve/sieve.y"
                                 { (yyval.cl) = build_rej_err(sscript, B_ERROR, (yyvsp[-1].sval)); }
#line 2446 "sieve/sieve.c"
    break;

  case 23: /* control: INCLUDE itags string ';'  */
#line 435 "sieve/sieve.y"
                                 { (yyval.cl) = build_include(sscript, (yyvsp[-2].cl), (yyvsp[-1].sval)); }
#line 2452 "sieve/sieve.c"
    break;

  case 24: /* control: RETURN ';'  */
#line 436 "sieve/sieve.y"
                                 { (yyval.cl) = new_command(B_RETURN, sscript); }
#line 2458 "sieve/sieve.c"
    break;

  case 25: /* thenelse: test block elsif  */
#line 440 "sieve/sieve.y"
                                 { 
                                     if ((yyvsp[-2].test)->ignore_err) {
                                         /* end of block - decrement counter */
                                         sscript->ignore_err--;
                                     }

                                     (yyval.cl) = new_if((yyvsp[-2].test), (yyvsp[-1].cl), (yyvsp[0].cl));
                                 }
#line 2471 "sieve/sieve.c"
    break;

  case 26: /* elsif: %empty  */
#line 451 "sieve/sieve.y"
                                 { (yyval.cl) = NULL; }
#line 2477 "sieve/sieve.c"
    break;

  case 27: /* elsif: ELSIF thenelse  */
#line 452 "sieve/sieve.y"
                                 { (yyval.cl) = (yyvsp[0].cl); }
#line 2483 "sieve/sieve.c"
    break;

  case 28: /* elsif: ELSE block  */
#line 453 "sieve/sieve.y"
                                 { (yyval.cl) = (yyvsp[0].cl); }
#line 2489 "sieve/sieve.c"
    break;

  case 29: /* block: '{' commands '}'  */
#line 457 "sieve/sieve.y"
                                 { (yyval.cl) = (yyvsp[-1].cl); }
#line 2495 "sieve/sieve.c"
    break;

  case 30: /* block: '{' '}'  */
#line 458 "sieve/sieve.y"
                                 { (yyval.cl) = NULL; }
#line 2501 "sieve/sieve.c"
    break;

  case 31: /* itags: %empty  */
#line 463 "sieve/sieve.y"
                                 { (yyval.cl) = new_command(B_INCLUDE, sscript); }
#line 2507 "sieve/sieve.c"
    break;

  case 32: /* itags: itags location  */
#line 464 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.inc.location != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_CONFLICTING_TAGS,
                                                      ":personal", ":location");
                                     }

                                     (yyval.cl)->u.inc.location = (yyvsp[0].nval);
                                 }
#line 2521 "sieve/sieve.c"
    break;

  case 33: /* itags: itags ONCE  */
#line 473 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.inc.once != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":once");
                                     }

                                     (yyval.cl)->u.inc.once = INC_ONCE_MASK;
                                 }
#line 2535 "sieve/sieve.c"
    break;

  case 34: /* itags: itags OPTIONAL  */
#line 482 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.inc.optional != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":optional");
                                     }

                                     (yyval.cl)->u.inc.optional = INC_OPTIONAL_MASK;
                                 }
#line 2549 "sieve/sieve.c"
    break;

  case 35: /* location: PERSONAL  */
#line 495 "sieve/sieve.y"
                                 { (yyval.nval) = B_PERSONAL; }
#line 2555 "sieve/sieve.c"
    break;

  case 36: /* location: GLOBAL  */
#line 496 "sieve/sieve.y"
                                 { (yyval.nval) = B_GLOBAL;   }
#line 2561 "sieve/sieve.c"
    break;

  case 37: /* action: KEEP ktags  */
#line 503 "sieve/sieve.y"
                                 { (yyval.cl) = build_keep(sscript, (yyvsp[0].cl)); }
#line 2567 "sieve/sieve.c"
    break;

  case 38: /* action: FILEINTO ftags string  */
#line 504 "sieve/sieve.y"
                                 { (yyval.cl) = build_fileinto(sscript, (yyvsp[-1].cl), (yyvsp[0].sval)); }
#line 2573 "sieve/sieve.c"
    break;

  case 39: /* action: REDIRECT rtags string  */
#line 505 "sieve/sieve.y"
                                 { (yyval.cl) = build_redirect(sscript, (yyvsp[-1].cl), (yyvsp[0].sval)); }
#line 2579 "sieve/sieve.c"
    break;

  case 40: /* action: DISCARD  */
#line 506 "sieve/sieve.y"
                                 { (yyval.cl) = new_command(B_DISCARD, sscript); }
#line 2585 "sieve/sieve.c"
    break;

  case 41: /* action: SET stags string string  */
#line 508 "sieve/sieve.y"
                                 { (yyval.cl) = build_set(sscript, (yyvsp[-2].cl), (yyvsp[-1].sval), (yyvsp[0].sval)); }
#line 2591 "sieve/sieve.c"
    break;

  case 42: /* action: VACATION vtags string  */
#line 509 "sieve/sieve.y"
                                 { (yyval.cl) = build_vacation(sscript, (yyvsp[-1].cl), (yyvsp[0].sval)); }
#line 2597 "sieve/sieve.c"
    break;

  case 43: /* action: flagaction flagtags stringlist  */
#line 513 "sieve/sieve.y"
                                 { (yyval.cl) = build_flag(sscript, (yyvsp[-1].cl), (yyvsp[0].sl)); }
#line 2603 "sieve/sieve.c"
    break;

  case 44: /* action: flagmark  */
#line 516 "sieve/sieve.y"
                                 { (yyval.cl) = build_flag(sscript,
                                                   new_command((yyvsp[0].nval), sscript),
                                                   strarray_split("\\Flagged",
                                                                  NULL, 0)); }
#line 2612 "sieve/sieve.c"
    break;

  case 45: /* action: ADDHEADER ahtags string string  */
#line 522 "sieve/sieve.y"
                                 { (yyval.cl) = build_addheader(sscript,
                                                        (yyvsp[-2].cl), (yyvsp[-1].sval), (yyvsp[0].sval)); }
#line 2619 "sieve/sieve.c"
    break;

  case 46: /* action: DELETEHEADER dhtags string optstringlist  */
#line 525 "sieve/sieve.y"
                                 { (yyval.cl) = build_deleteheader(sscript,
                                                           (yyvsp[-2].cl), (yyvsp[-1].sval), (yyvsp[0].sl)); }
#line 2626 "sieve/sieve.c"
    break;

  case 47: /* action: reject string  */
#line 528 "sieve/sieve.y"
                                 { (yyval.cl) = build_rej_err(sscript, (yyvsp[-1].nval), (yyvsp[0].sval)); }
#line 2632 "sieve/sieve.c"
    break;

  case 48: /* action: NOTIFY ntags string  */
#line 529 "sieve/sieve.y"
                                 { (yyval.cl) = build_notify(sscript,
                                                     B_ENOTIFY, (yyvsp[-1].cl), (yyvsp[0].sval)); }
#line 2639 "sieve/sieve.c"
    break;

  case 49: /* action: NOTIFY ntags  */
#line 532 "sieve/sieve.y"
                                 { (yyval.cl) = build_notify(sscript,
                                                     B_NOTIFY, (yyvsp[0].cl), NULL); }
#line 2646 "sieve/sieve.c"
    break;

  case 50: /* action: DENOTIFY dtags  */
#line 535 "sieve/sieve.y"
                                 { (yyval.cl) = build_denotify(sscript, (yyvsp[0].cl)); }
#line 2652 "sieve/sieve.c"
    break;

  case 51: /* action: LOG string  */
#line 536 "sieve/sieve.y"
                                 { (yyval.cl) = build_log(sscript, (yyvsp[0].sval)); }
#line 2658 "sieve/sieve.c"
    break;

  case 52: /* action: SNOOZE sntags timelist  */
#line 537 "sieve/sieve.y"
                                 { (yyval.cl) = build_snooze(sscript, (yyvsp[-1].cl), (yyvsp[0].nl)); }
#line 2664 "sieve/sieve.c"
    break;

  case 53: /* action: PROCESSIMIP imiptags  */
#line 538 "sieve/sieve.y"
                                 { (yyval.cl) = build_imip(sscript, (yyvsp[0].cl)); }
#line 2670 "sieve/sieve.c"
    break;

  case 54: /* ktags: %empty  */
#line 543 "sieve/sieve.y"
                                 {
                                     (yyval.cl) = new_command(B_KEEP, sscript);
                                     flags = &((yyval.cl)->u.k.flags);
                                 }
#line 2679 "sieve/sieve.c"
    break;

  case 56: /* flags: FLAGS stringlist  */
#line 552 "sieve/sieve.y"
                                 {
                                     /* **flags assigned by the calling rule */
                                     if (*flags != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":flags");
                                         strarray_free(*flags);
                                     }
                                     else if (!supported(SIEVE_CAPA_IMAP4FLAGS)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "imap4flags");
                                     }

                                     *flags = (yyvsp[0].sl);
                                 }
#line 2700 "sieve/sieve.c"
    break;

  case 57: /* ftags: %empty  */
#line 572 "sieve/sieve.y"
                                 {
                                     (yyval.cl) = new_command(B_FILEINTO, sscript);
                                     copy = &((yyval.cl)->u.f.copy);
                                     flags = &((yyval.cl)->u.f.flags);
                                     create = &((yyval.cl)->u.f.create);
                                     specialuse = &((yyval.cl)->u.f.specialuse);
                                     mailboxid = &((yyval.cl)->u.f.mailboxid);
                                 }
#line 2713 "sieve/sieve.c"
    break;

  case 63: /* copy: COPY  */
#line 589 "sieve/sieve.y"
                                 {
                                     /* *copy assigned by the calling rule */
                                     if ((*copy)++) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":copy");
                                     }
                                     else if (!supported(SIEVE_CAPA_COPY)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "copy");
                                     }
                                 }
#line 2731 "sieve/sieve.c"
    break;

  case 64: /* create: CREATE  */
#line 606 "sieve/sieve.y"
                                {
                                     /* *create assigned by the calling rule */
                                     if ((*create)++) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":create");
                                     }
                                     else if (!supported(SIEVE_CAPA_MAILBOX)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "mailbox");
                                     }
                                 }
#line 2749 "sieve/sieve.c"
    break;

  case 65: /* specialuse: SPECIALUSE string  */
#line 623 "sieve/sieve.y"
                                 {
                                     /* **specialuse assigned by calling rule */
                                     if (*specialuse != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":specialuse");
                                         free(*specialuse);
                                     }
                                     else if (!supported(SIEVE_CAPA_SPECIAL_USE)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "special-use");
                                     }
                                     else if (*mailboxid != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_CONFLICTING_TAGS,
                                                      ":specialuse",
                                                      ":mailboxid");
                                     }

                                     *specialuse = (yyvsp[0].sval);
                                 }
#line 2776 "sieve/sieve.c"
    break;

  case 66: /* mailboxid: MAILBOXID string  */
#line 648 "sieve/sieve.y"
                                 {
                                     /* **mailboxid assigned by calling rule */
                                     if (*mailboxid != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":mailboxid");
                                         free(*mailboxid);
                                     }
                                     else if (!supported(SIEVE_CAPA_MAILBOXID)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "mailboxid");
                                     }
                                     else if (*specialuse != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_CONFLICTING_TAGS,
                                                      ":mailboxid",
                                                      ":specialuse");
                                     }

                                     *mailboxid = (yyvsp[0].sval);
                                 }
#line 2803 "sieve/sieve.c"
    break;

  case 67: /* rtags: %empty  */
#line 674 "sieve/sieve.y"
                                 {
                                     (yyval.cl) = new_command(B_REDIRECT, sscript);
                                     copy = &((yyval.cl)->u.r.copy);
                                 }
#line 2812 "sieve/sieve.c"
    break;

  case 69: /* rtags: rtags LIST  */
#line 679 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.r.list++) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":list");
                                     }
                                     else if (!supported(SIEVE_CAPA_EXTLISTS)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "extlists");
                                     }
                                 }
#line 2829 "sieve/sieve.c"
    break;

  case 70: /* rtags: rtags delbytags  */
#line 691 "sieve/sieve.y"
                                 {
                                     if (!supported(SIEVE_CAPA_REDIR_DELBY)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "redirect-deliverby");
                                     }
                                 }
#line 2841 "sieve/sieve.c"
    break;

  case 71: /* rtags: rtags dsntags  */
#line 698 "sieve/sieve.y"
                                 {
                                     if (!supported(SIEVE_CAPA_REDIR_DSN)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "redirect-dsn");
                                     }
                                 }
#line 2853 "sieve/sieve.c"
    break;

  case 72: /* delbytags: BYTIMEREL NUMBER  */
#line 708 "sieve/sieve.y"
                                 {
                                     /* $0 refers to rtags */
                                     commandlist_t *c = (yyvsp[-2].cl);

                                     if (c->u.r.bytime != NULL) {
                                         if (isdigit(c->u.r.bytime[0])) {
                                             sieveerror_c(sscript,
                                                          SIEVE_CONFLICTING_TAGS,
                                                          ":bytimerelative",
                                                          ":bytimeabsolute");
                                         }
                                         else {
                                             sieveerror_c(sscript,
                                                          SIEVE_DUPLICATE_TAG,
                                                          ":bytimerelative");
                                         }
                                     }                                         

                                     struct buf buf = BUF_INITIALIZER;
                                     buf_printf(&buf, "+%d", (yyvsp[0].nval));
                                     c->u.r.bytime = buf_release(&buf);
                                 }
#line 2880 "sieve/sieve.c"
    break;

  case 73: /* delbytags: BYTIMEABS string  */
#line 730 "sieve/sieve.y"
                                 {
                                     /* $0 refers to rtags */
                                     commandlist_t *c = (yyvsp[-2].cl);

                                     if (c->u.r.bytime != NULL) {
                                         if (isdigit(c->u.r.bytime[0])) {
                                             sieveerror_c(sscript,
                                                          SIEVE_DUPLICATE_TAG,
                                                          ":bytimeabsolute");
                                         }
                                         else {
                                             sieveerror_c(sscript,
                                                          SIEVE_CONFLICTING_TAGS,
                                                          ":bytimeabsolute",
                                                          ":bytimerelative");
                                         }
                                     }

                                     c->u.r.bytime = (yyvsp[0].sval);
                                 }
#line 2905 "sieve/sieve.c"
    break;

  case 74: /* delbytags: BYMODE string  */
#line 750 "sieve/sieve.y"
                                 {
                                     /* $0 refers to rtags */
                                     commandlist_t *c = (yyvsp[-2].cl);

                                     if (c->u.r.bymode != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":bymode");
                                     }

                                     c->u.r.bymode = (yyvsp[0].sval);
                                 }
#line 2922 "sieve/sieve.c"
    break;

  case 75: /* delbytags: BYTRACE  */
#line 762 "sieve/sieve.y"
                                 {
                                     /* $0 refers to rtags */
                                     commandlist_t *c = (yyvsp[-1].cl);

                                     if (c->u.r.bytrace != 0) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":bytrace");
                                     }

                                     c->u.r.bytrace = 1;
                                 }
#line 2939 "sieve/sieve.c"
    break;

  case 76: /* dsntags: DSNNOTIFY string  */
#line 778 "sieve/sieve.y"
                                 {
                                     /* $0 refers to rtags */
                                     commandlist_t *c = (yyvsp[-2].cl);

                                     if (c->u.r.dsn_notify != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":notify");
                                     }                                         

                                     c->u.r.dsn_notify = (yyvsp[0].sval);
                                 }
#line 2956 "sieve/sieve.c"
    break;

  case 77: /* dsntags: DSNRET string  */
#line 790 "sieve/sieve.y"
                                 {
                                     /* $0 refers to rtags */
                                     commandlist_t *c = (yyvsp[-2].cl);

                                     if (c->u.r.dsn_ret != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":ret");
                                     }

                                     c->u.r.dsn_ret = (yyvsp[0].sval);
                                 }
#line 2973 "sieve/sieve.c"
    break;

  case 78: /* stags: %empty  */
#line 806 "sieve/sieve.y"
                                 { (yyval.cl) = new_command(B_SET, sscript); }
#line 2979 "sieve/sieve.c"
    break;

  case 79: /* stags: stags mod40  */
#line 807 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.s.modifiers & BFV_MOD40_MASK) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MULTIPLE_TAGS,
                                                      "precedence 40 modifier");
                                     }

                                     (yyval.cl)->u.s.modifiers |= (yyvsp[0].nval);
                                 }
#line 2993 "sieve/sieve.c"
    break;

  case 80: /* stags: stags mod30  */
#line 816 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.s.modifiers & BFV_MOD30_MASK) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MULTIPLE_TAGS,
                                                      "precedence 30 modifier");
                                     }

                                     (yyval.cl)->u.s.modifiers |= (yyvsp[0].nval);
                                 }
#line 3007 "sieve/sieve.c"
    break;

  case 81: /* stags: stags mod20  */
#line 825 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.s.modifiers & BFV_MOD20_MASK) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MULTIPLE_TAGS,
                                                      "precedence 20 modifier");
                                     }

                                     (yyval.cl)->u.s.modifiers |= (yyvsp[0].nval);
                                 }
#line 3021 "sieve/sieve.c"
    break;

  case 82: /* stags: stags mod15  */
#line 834 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.s.modifiers & BFV_MOD15_MASK) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MULTIPLE_TAGS,
                                                      "precedence 15 modifier");
                                     }

                                     (yyval.cl)->u.s.modifiers |= (yyvsp[0].nval);
                                 }
#line 3035 "sieve/sieve.c"
    break;

  case 83: /* stags: stags mod10  */
#line 843 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.s.modifiers & BFV_MOD10_MASK) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MULTIPLE_TAGS,
                                                      "precedence 10 modifier");
                                     }

                                     (yyval.cl)->u.s.modifiers |= (yyvsp[0].nval);
                                 }
#line 3049 "sieve/sieve.c"
    break;

  case 84: /* mod40: LOWER  */
#line 856 "sieve/sieve.y"
                                { (yyval.nval) = BFV_LOWER; }
#line 3055 "sieve/sieve.c"
    break;

  case 85: /* mod40: UPPER  */
#line 857 "sieve/sieve.y"
                                { (yyval.nval) = BFV_UPPER; }
#line 3061 "sieve/sieve.c"
    break;

  case 86: /* mod30: LOWERFIRST  */
#line 860 "sieve/sieve.y"
                                { (yyval.nval) = BFV_LOWERFIRST; }
#line 3067 "sieve/sieve.c"
    break;

  case 87: /* mod30: UPPERFIRST  */
#line 861 "sieve/sieve.y"
                                { (yyval.nval) = BFV_UPPERFIRST; }
#line 3073 "sieve/sieve.c"
    break;

  case 88: /* mod20: QUOTEWILDCARD  */
#line 864 "sieve/sieve.y"
                                { (yyval.nval) = BFV_QUOTEWILDCARD; }
#line 3079 "sieve/sieve.c"
    break;

  case 89: /* mod20: QUOTEREGEX  */
#line 865 "sieve/sieve.y"
                                { 
                                     if (!supported(SIEVE_CAPA_REGEX)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "regex");
                                     }

                                     (yyval.nval) = BFV_QUOTEREGEX;
                                 }
#line 3093 "sieve/sieve.c"
    break;

  case 90: /* mod15: ENCODEURL  */
#line 877 "sieve/sieve.y"
                                 { 
                                     if (!supported(SIEVE_CAPA_ENOTIFY)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "enotify");
                                     }

                                     (yyval.nval) = BFV_ENCODEURL;
                                 }
#line 3107 "sieve/sieve.c"
    break;

  case 91: /* mod10: LENGTH  */
#line 888 "sieve/sieve.y"
                                 { (yyval.nval) = BFV_LENGTH; }
#line 3113 "sieve/sieve.c"
    break;

  case 92: /* vtags: %empty  */
#line 893 "sieve/sieve.y"
                                 {
                                     (yyval.cl) = new_command(B_VACATION, sscript);
                                     flags = &((yyval.cl)->u.v.fcc.flags);
                                     create = &((yyval.cl)->u.v.fcc.create);
                                     specialuse = &((yyval.cl)->u.v.fcc.specialuse);
                                     mailboxid = &((yyval.cl)->u.v.fcc.mailboxid);
                                     fccfolder = &((yyval.cl)->u.v.fcc.folder);
                                 }
#line 3126 "sieve/sieve.c"
    break;

  case 93: /* vtags: vtags DAYS NUMBER  */
#line 901 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.v.seconds != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":days");
                                     }

                                     (yyval.cl)->u.v.seconds = (yyvsp[0].nval) * DAY2SEC;
                                 }
#line 3140 "sieve/sieve.c"
    break;

  case 94: /* vtags: vtags SECONDS NUMBER  */
#line 910 "sieve/sieve.y"
                                 {
                                     if (!supported(SIEVE_CAPA_VACATION_SEC)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "vacation-seconds");
                                     }
                                     if ((yyval.cl)->u.v.seconds != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":seconds");
                                     }

                                     (yyval.cl)->u.v.seconds = (yyvsp[0].nval);
                                 }
#line 3159 "sieve/sieve.c"
    break;

  case 95: /* vtags: vtags SUBJECT string  */
#line 924 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.v.subject != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":subject");
                                         free((yyval.cl)->u.v.subject);
                                     }

                                     (yyval.cl)->u.v.subject = (yyvsp[0].sval);
                                 }
#line 3174 "sieve/sieve.c"
    break;

  case 96: /* vtags: vtags FROM string  */
#line 934 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.v.from != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":from");
                                         free((yyval.cl)->u.v.from);
                                     }

                                     (yyval.cl)->u.v.from = (yyvsp[0].sval);
                                 }
#line 3189 "sieve/sieve.c"
    break;

  case 97: /* vtags: vtags ADDRESSES stringlist  */
#line 946 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.v.addresses != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":addresses");
                                         strarray_free((yyval.cl)->u.v.addresses);
                                     }

                                     (yyval.cl)->u.v.addresses = (yyvsp[0].sl);
                                 }
#line 3204 "sieve/sieve.c"
    break;

  case 98: /* vtags: vtags MIME  */
#line 956 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.v.mime != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":mime");
                                     }

                                     (yyval.cl)->u.v.mime = 1;
                                 }
#line 3218 "sieve/sieve.c"
    break;

  case 99: /* vtags: vtags HANDLE string  */
#line 965 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.v.handle != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":handle");
                                         free((yyval.cl)->u.v.handle);
                                     }

                                     (yyval.cl)->u.v.handle = (yyvsp[0].sval);
                                 }
#line 3233 "sieve/sieve.c"
    break;

  case 101: /* fcctags: FCC string  */
#line 979 "sieve/sieve.y"
                                 {
                                     /* **fccfolder assigned by the calling rule */
                                     if (*fccfolder != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":fcc");
                                         free(*fccfolder);
                                     }
                                     else if (!supported(SIEVE_CAPA_FCC)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "fcc");
                                     }

                                     *fccfolder = (yyvsp[0].sval);
                                 }
#line 3254 "sieve/sieve.c"
    break;

  case 106: /* flagaction: SETFLAG  */
#line 1003 "sieve/sieve.y"
                                 { (yyval.nval) = B_SETFLAG;    }
#line 3260 "sieve/sieve.c"
    break;

  case 107: /* flagaction: ADDFLAG  */
#line 1004 "sieve/sieve.y"
                                 { (yyval.nval) = B_ADDFLAG;    }
#line 3266 "sieve/sieve.c"
    break;

  case 108: /* flagaction: REMOVEFLAG  */
#line 1005 "sieve/sieve.y"
                                 { (yyval.nval) = B_REMOVEFLAG; }
#line 3272 "sieve/sieve.c"
    break;

  case 109: /* flagtags: %empty  */
#line 1010 "sieve/sieve.y"
                                 { (yyval.cl) = new_command((yyvsp[0].nval), sscript); }
#line 3278 "sieve/sieve.c"
    break;

  case 110: /* flagtags: flagtags string  */
#line 1011 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.fl.variable != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_ARG,
                                                      "variablename");
                                         free((yyval.cl)->u.fl.variable);
                                     }
                                     else if (!supported(SIEVE_CAPA_IMAP4FLAGS)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "imap4flags");
                                     }

                                     (yyval.cl)->u.fl.variable = (yyvsp[0].sval);
                                 }
#line 3298 "sieve/sieve.c"
    break;

  case 111: /* flagmark: MARK  */
#line 1030 "sieve/sieve.y"
                                 { (yyval.nval) = B_ADDFLAG;   }
#line 3304 "sieve/sieve.c"
    break;

  case 112: /* flagmark: UNMARK  */
#line 1031 "sieve/sieve.y"
                                 { (yyval.nval) = B_REMOVEFLAG; }
#line 3310 "sieve/sieve.c"
    break;

  case 113: /* ahtags: %empty  */
#line 1036 "sieve/sieve.y"
                                 { (yyval.cl) = new_command(B_ADDHEADER, sscript); }
#line 3316 "sieve/sieve.c"
    break;

  case 114: /* ahtags: ahtags LAST  */
#line 1037 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.ah.index < 0) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":last");
                                     }

                                     (yyval.cl)->u.ah.index = -1;
                                 }
#line 3330 "sieve/sieve.c"
    break;

  case 115: /* dhtags: %empty  */
#line 1050 "sieve/sieve.y"
                                 {
                                     (yyval.cl) = new_command(B_DELETEHEADER, sscript);
                                     ctags = &((yyval.cl)->u.dh.comp);
                                 }
#line 3339 "sieve/sieve.c"
    break;

  case 120: /* reject: REJCT  */
#line 1062 "sieve/sieve.y"
                                 { (yyval.nval) = B_REJECT;  }
#line 3345 "sieve/sieve.c"
    break;

  case 121: /* reject: EREJECT  */
#line 1063 "sieve/sieve.y"
                                 { (yyval.nval) = B_EREJECT; }
#line 3351 "sieve/sieve.c"
    break;

  case 122: /* ntags: %empty  */
#line 1074 "sieve/sieve.y"
                                 {
                                     (yyval.cl) = new_command(B_ENOTIFY, sscript);
                                     flags = &((yyval.cl)->u.n.fcc.flags);
                                     create = &((yyval.cl)->u.n.fcc.create);
                                     specialuse = &((yyval.cl)->u.n.fcc.specialuse);
                                     mailboxid = &((yyval.cl)->u.n.fcc.mailboxid);
                                     fccfolder = &((yyval.cl)->u.n.fcc.folder);
                                 }
#line 3364 "sieve/sieve.c"
    break;

  case 123: /* ntags: ntags FROM string  */
#line 1084 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.n.from != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":from");
                                         free((yyval.cl)->u.n.from);
                                     }

                                     (yyval.cl)->u.n.from = (yyvsp[0].sval);
                                 }
#line 3379 "sieve/sieve.c"
    break;

  case 124: /* ntags: ntags IMPORTANCE priority  */
#line 1096 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.n.priority != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":importance");
                                     }

                                     (yyval.cl)->u.n.priority = (yyvsp[0].nval);
                                 }
#line 3393 "sieve/sieve.c"
    break;

  case 126: /* ntags: ntags NID string  */
#line 1108 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.n.id != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":id");
                                         free((yyval.cl)->u.n.id);
                                     }

                                     (yyval.cl)->u.n.id = (yyvsp[0].sval);
                                 }
#line 3408 "sieve/sieve.c"
    break;

  case 127: /* ntags: ntags METHOD string  */
#line 1118 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.n.method != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":method");
                                         free((yyval.cl)->u.n.method);
                                     }

                                     (yyval.cl)->u.n.method = (yyvsp[0].sval);
                                 }
#line 3423 "sieve/sieve.c"
    break;

  case 128: /* ntags: ntags priority  */
#line 1128 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.n.priority != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MULTIPLE_TAGS,
                                                      "priority");
                                     }

                                     (yyval.cl)->u.n.priority = (yyvsp[0].nval);
                                 }
#line 3437 "sieve/sieve.c"
    break;

  case 129: /* ntags: ntags MESSAGE string  */
#line 1139 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.n.message != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":message");
                                         free((yyval.cl)->u.n.message);
                                     }

                                     (yyval.cl)->u.n.message = (yyvsp[0].sval);
                                 }
#line 3452 "sieve/sieve.c"
    break;

  case 130: /* ntags: ntags OPTIONS stringlist  */
#line 1151 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.n.options != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":options");
                                         strarray_free((yyval.cl)->u.n.options);
                                     }

                                     (yyval.cl)->u.n.options = (yyvsp[0].sl);
                                 }
#line 3467 "sieve/sieve.c"
    break;

  case 131: /* priority: LOW  */
#line 1165 "sieve/sieve.y"
                                 { (yyval.nval) = B_LOW;    }
#line 3473 "sieve/sieve.c"
    break;

  case 132: /* priority: NORMAL  */
#line 1166 "sieve/sieve.y"
                                 { (yyval.nval) = B_NORMAL; }
#line 3479 "sieve/sieve.c"
    break;

  case 133: /* priority: HIGH  */
#line 1167 "sieve/sieve.y"
                                 { (yyval.nval) = B_HIGH;   }
#line 3485 "sieve/sieve.c"
    break;

  case 134: /* dtags: %empty  */
#line 1172 "sieve/sieve.y"
                                 {
                                     (yyval.cl) = new_command(B_DENOTIFY, sscript);
                                     ctags = &((yyval.cl)->u.d.comp);
                                 }
#line 3494 "sieve/sieve.c"
    break;

  case 135: /* dtags: dtags priority  */
#line 1176 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.d.priority != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MULTIPLE_TAGS,
                                                      "priority");
                                     }

                                     (yyval.cl)->u.d.priority = (yyvsp[0].nval);
                                 }
#line 3508 "sieve/sieve.c"
    break;

  case 136: /* dtags: dtags matchtype string  */
#line 1187 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.d.pattern) free((yyval.cl)->u.d.pattern);
                                     (yyval.cl)->u.d.pattern = (yyvsp[0].sval);
                                 }
#line 3517 "sieve/sieve.c"
    break;

  case 137: /* sntags: %empty  */
#line 1195 "sieve/sieve.y"
                                 {
                                     (yyval.cl) = new_command(B_SNOOZE, sscript);
                                     create = &((yyval.cl)->u.sn.f.create);
                                     specialuse = &((yyval.cl)->u.sn.f.specialuse);
                                     mailboxid = &((yyval.cl)->u.sn.f.mailboxid);
                                 }
#line 3528 "sieve/sieve.c"
    break;

  case 138: /* sntags: sntags MAILBOX string  */
#line 1201 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.sn.f.folder != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":mailbox");
                                         free((yyval.cl)->u.sn.f.folder);
                                     }

                                     (yyval.cl)->u.sn.f.folder = (yyvsp[0].sval);
                                 }
#line 3543 "sieve/sieve.c"
    break;

  case 142: /* sntags: sntags ADDFLAGS stringlist  */
#line 1216 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.sn.addflags != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":addflags");
                                         free((yyval.cl)->u.sn.addflags);
                                     }
                                     else if (!supported(SIEVE_CAPA_IMAP4FLAGS)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "imap4flags");
                                     }

                                     (yyval.cl)->u.sn.addflags = (yyvsp[0].sl);
                                 }
#line 3563 "sieve/sieve.c"
    break;

  case 143: /* sntags: sntags REMOVEFLAGS stringlist  */
#line 1232 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.sn.removeflags != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":removeflags");
                                         free((yyval.cl)->u.sn.removeflags);
                                     }
                                     else if (!supported(SIEVE_CAPA_IMAP4FLAGS)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "imap4flags");
                                     }

                                     (yyval.cl)->u.sn.removeflags = (yyvsp[0].sl);
                                 }
#line 3583 "sieve/sieve.c"
    break;

  case 144: /* sntags: sntags WEEKDAYS weekdaylist  */
#line 1248 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.sn.days != 0) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":weekdays");
                                     }

                                     (yyval.cl)->u.sn.days = (yyvsp[0].nval);
                                 }
#line 3597 "sieve/sieve.c"
    break;

  case 145: /* sntags: sntags TZID string  */
#line 1257 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.sn.tzid != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":tzid");
                                         free((yyval.cl)->u.sn.tzid);
                                     }

                                     (yyval.cl)->u.sn.tzid = (yyvsp[0].sval);
                                 }
#line 3612 "sieve/sieve.c"
    break;

  case 147: /* weekdaylist: '[' weekdays ']'  */
#line 1271 "sieve/sieve.y"
                                 { (yyval.nval) = (yyvsp[-1].nval); }
#line 3618 "sieve/sieve.c"
    break;

  case 149: /* weekdays: weekdays ',' weekday  */
#line 1276 "sieve/sieve.y"
                                 { (yyval.nval) = (yyvsp[-2].nval) | (yyvsp[0].nval); }
#line 3624 "sieve/sieve.c"
    break;

  case 150: /* weekday: STRING  */
#line 1280 "sieve/sieve.y"
                                 { (yyval.nval) = verify_weekday(sscript, (yyvsp[0].sval)); }
#line 3630 "sieve/sieve.c"
    break;

  case 152: /* timelist: '[' times ']'  */
#line 1285 "sieve/sieve.y"
                                 { (yyval.nl) = (yyvsp[-1].nl); }
#line 3636 "sieve/sieve.c"
    break;

  case 154: /* times: times ',' time  */
#line 1290 "sieve/sieve.y"
                                 { (yyval.nl) = (yyvsp[-2].nl); arrayu64_add((yyval.nl), (yyvsp[0].nval)); }
#line 3642 "sieve/sieve.c"
    break;

  case 155: /* time1: time  */
#line 1294 "sieve/sieve.y"
                                 {
                                     (yyval.nl) = arrayu64_new();
                                     arrayu64_add((yyval.nl), (yyvsp[0].nval));
                                 }
#line 3651 "sieve/sieve.c"
    break;

  case 156: /* time: STRING  */
#line 1301 "sieve/sieve.y"
                                 { (yyval.nval) = verify_time(sscript, (yyvsp[0].sval)); }
#line 3657 "sieve/sieve.c"
    break;

  case 157: /* imiptags: %empty  */
#line 1306 "sieve/sieve.y"
                                 { (yyval.cl) = new_command(B_PROCESSIMIP, sscript); }
#line 3663 "sieve/sieve.c"
    break;

  case 158: /* imiptags: imiptags INVITESONLY  */
#line 1307 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.imip.invites_only) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":invitesonly");
                                     }
                                     else if ((yyval.cl)->u.imip.updates_only) {
                                         sieveerror_c(sscript,
                                                      SIEVE_CONFLICTING_TAGS,
                                                      ":invitesonly",
                                                      ":updatesonly");
                                     }
                                     else if ((yyval.cl)->u.imip.delete_canceled) {
                                         sieveerror_c(sscript,
                                                      SIEVE_CONFLICTING_TAGS,
                                                      ":invitesonly",
                                                      ":deletecanceled");
                                     }

                                     (yyval.cl)->u.imip.invites_only = 1;
                                 }
#line 3689 "sieve/sieve.c"
    break;

  case 159: /* imiptags: imiptags UPDATESONLY  */
#line 1329 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.imip.updates_only) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":updatesonly");
                                     }
                                     else if ((yyval.cl)->u.imip.invites_only) {
                                         sieveerror_c(sscript,
                                                      SIEVE_CONFLICTING_TAGS,
                                                      ":invitesonly",
                                                      ":updatesonly");
                                     }
                                     else if ((yyval.cl)->u.imip.calendarid != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_CONFLICTING_TAGS,
                                                      ":updatesonly",
                                                      ":calendarid");
                                     }

                                     (yyval.cl)->u.imip.updates_only = 1;
                                 }
#line 3715 "sieve/sieve.c"
    break;

  case 160: /* imiptags: imiptags DELETECANCELED  */
#line 1352 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.imip.delete_canceled) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":deletecanceled");
                                     }
                                     else if ((yyval.cl)->u.imip.invites_only) {
                                         sieveerror_c(sscript,
                                                      SIEVE_CONFLICTING_TAGS,
                                                      ":invitesonly",
                                                      ":deletecanceled");
                                     }

                                     (yyval.cl)->u.imip.delete_canceled = 1;
                                 }
#line 3735 "sieve/sieve.c"
    break;

  case 161: /* imiptags: imiptags CALENDARID string  */
#line 1368 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.imip.calendarid != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":calendarid");
                                         free((yyval.cl)->u.imip.calendarid);
                                     }
                                     else if ((yyval.cl)->u.imip.updates_only) {
                                         sieveerror_c(sscript,
                                                      SIEVE_CONFLICTING_TAGS,
                                                      ":updatesonly",
                                                      ":calendarid");
                                     }

                                     (yyval.cl)->u.imip.calendarid = (yyvsp[0].sval);
                                 }
#line 3756 "sieve/sieve.c"
    break;

  case 162: /* imiptags: imiptags OUTCOME string  */
#line 1385 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.imip.outcome_var != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":outcome");
                                         free((yyval.cl)->u.imip.outcome_var);
                                     }
                                     else if (!supported(SIEVE_CAPA_VARIABLES)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "variables");
                                     }

                                     (yyval.cl)->u.imip.outcome_var = (yyvsp[0].sval);
                                 }
#line 3776 "sieve/sieve.c"
    break;

  case 163: /* imiptags: imiptags ERRSTR string  */
#line 1400 "sieve/sieve.y"
                                 {
                                     if ((yyval.cl)->u.imip.errstr_var != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":errstr");
                                         free((yyval.cl)->u.imip.errstr_var);
                                     }
                                     else if (!supported(SIEVE_CAPA_VARIABLES)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "variables");
                                     }

                                     (yyval.cl)->u.imip.errstr_var = (yyvsp[0].sval);
                                 }
#line 3796 "sieve/sieve.c"
    break;

  case 164: /* testlist: '(' tests ')'  */
#line 1421 "sieve/sieve.y"
                                 { (yyval.testl) = (yyvsp[-1].testl); }
#line 3802 "sieve/sieve.c"
    break;

  case 165: /* tests: test  */
#line 1425 "sieve/sieve.y"
                                 { (yyval.testl) = new_testlist((yyvsp[0].test), NULL); }
#line 3808 "sieve/sieve.c"
    break;

  case 166: /* tests: test ',' tests  */
#line 1426 "sieve/sieve.y"
                                 { (yyval.testl) = new_testlist((yyvsp[-2].test), (yyvsp[0].testl)); }
#line 3814 "sieve/sieve.c"
    break;

  case 167: /* test: ANYOF testlist  */
#line 1430 "sieve/sieve.y"
                                 { (yyval.test) = build_anyof(sscript, (yyvsp[0].testl)); }
#line 3820 "sieve/sieve.c"
    break;

  case 168: /* test: ALLOF testlist  */
#line 1431 "sieve/sieve.y"
                                 { (yyval.test) = build_allof(sscript, (yyvsp[0].testl)); }
#line 3826 "sieve/sieve.c"
    break;

  case 169: /* test: NOT test  */
#line 1432 "sieve/sieve.y"
                                 { (yyval.test) = build_not(sscript, (yyvsp[0].test));   }
#line 3832 "sieve/sieve.c"
    break;

  case 170: /* test: SFALSE  */
#line 1433 "sieve/sieve.y"
                                 { (yyval.test) = new_test(BC_FALSE, sscript); }
#line 3838 "sieve/sieve.c"
    break;

  case 171: /* test: STRUE  */
#line 1434 "sieve/sieve.y"
                                 { (yyval.test) = new_test(BC_TRUE, sscript);  }
#line 3844 "sieve/sieve.c"
    break;

  case 172: /* test: EXISTS stringlist  */
#line 1435 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_EXISTS, sscript);
                                     (yyval.test)->u.sl = (yyvsp[0].sl);
                                     (yyval.test)->nargs = bc_precompile((yyval.test)->args, "S",
                                                               (yyval.test)->u.sl);
                                 }
#line 3855 "sieve/sieve.c"
    break;

  case 173: /* test: SIZE sizetag NUMBER  */
#line 1441 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_SIZE, sscript);
                                     (yyval.test)->u.sz.t = (yyvsp[-1].nval);
                                     (yyval.test)->u.sz.n = (yyvsp[0].nval);
                                     (yyval.test)->nargs = bc_precompile((yyval.test)->args, "ii",
                                                               (yyval.test)->u.sz.t,
                                                               (yyval.test)->u.sz.n);
                                 }
#line 3868 "sieve/sieve.c"
    break;

  case 174: /* test: HEADERT htags stringlist stringlist  */
#line 1451 "sieve/sieve.y"
                                 { (yyval.test) = build_header(sscript, (yyvsp[-2].test), (yyvsp[-1].sl), (yyvsp[0].sl)); }
#line 3874 "sieve/sieve.c"
    break;

  case 175: /* test: ADDRESS atags stringlist stringlist  */
#line 1454 "sieve/sieve.y"
                                 { (yyval.test) = build_address(sscript, (yyvsp[-2].test), (yyvsp[-1].sl), (yyvsp[0].sl)); }
#line 3880 "sieve/sieve.c"
    break;

  case 176: /* test: ENVELOPE etags stringlist stringlist  */
#line 1456 "sieve/sieve.y"
                                 { (yyval.test) = build_envelope(sscript, (yyvsp[-2].test), (yyvsp[-1].sl), (yyvsp[0].sl)); }
#line 3886 "sieve/sieve.c"
    break;

  case 177: /* test: BODY btags stringlist  */
#line 1458 "sieve/sieve.y"
                                 { (yyval.test) = build_body(sscript, (yyvsp[-1].test), (yyvsp[0].sl)); }
#line 3892 "sieve/sieve.c"
    break;

  case 178: /* test: ENVIRONMENT envtags string stringlist  */
#line 1461 "sieve/sieve.y"
                                 { (yyval.test) = build_mbox_meta(sscript,
                                                        (yyvsp[-2].test), NULL, (yyvsp[-1].sval), (yyvsp[0].sl)); }
#line 3899 "sieve/sieve.c"
    break;

  case 179: /* test: STRINGT strtags stringlist stringlist  */
#line 1465 "sieve/sieve.y"
                                 { (yyval.test) = build_stringt(sscript, (yyvsp[-2].test), (yyvsp[-1].sl), (yyvsp[0].sl)); }
#line 3905 "sieve/sieve.c"
    break;

  case 180: /* test: HASFLAG hftags stringlist stringlist  */
#line 1472 "sieve/sieve.y"
                                 { (yyval.test) = build_hasflag(sscript, (yyvsp[-2].test), (yyvsp[-1].sl), (yyvsp[0].sl)); }
#line 3911 "sieve/sieve.c"
    break;

  case 181: /* test: HASFLAG hftags stringlist  */
#line 1474 "sieve/sieve.y"
                                 { (yyval.test) = build_hasflag(sscript, (yyvsp[-1].test), NULL, (yyvsp[0].sl)); }
#line 3917 "sieve/sieve.c"
    break;

  case 182: /* test: DATE dttags string string stringlist  */
#line 1477 "sieve/sieve.y"
                                 { (yyval.test) = build_date(sscript, (yyvsp[-3].test), (yyvsp[-2].sval), (yyvsp[-1].sval), (yyvsp[0].sl)); }
#line 3923 "sieve/sieve.c"
    break;

  case 183: /* test: CURRENTDATE cdtags string stringlist  */
#line 1480 "sieve/sieve.y"
                                 { (yyval.test) = build_date(sscript, (yyvsp[-2].test), NULL, (yyvsp[-1].sval), (yyvsp[0].sl)); }
#line 3929 "sieve/sieve.c"
    break;

  case 184: /* test: VALIDNOTIFYMETHOD stringlist  */
#line 1483 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_VALIDNOTIFYMETHOD, sscript);
                                     (yyval.test)->u.sl = (yyvsp[0].sl);
                                     (yyval.test)->nargs = bc_precompile((yyval.test)->args, "S",
                                                               (yyval.test)->u.sl);
                                 }
#line 3940 "sieve/sieve.c"
    break;

  case 185: /* test: NOTIFYMETHODCAPABILITY methtags string string stringlist  */
#line 1490 "sieve/sieve.y"
                                 { (yyval.test) = build_mbox_meta(sscript,
                                                        (yyvsp[-3].test), (yyvsp[-2].sval), (yyvsp[-1].sval), (yyvsp[0].sl)); }
#line 3947 "sieve/sieve.c"
    break;

  case 186: /* test: IHAVE stringlist  */
#line 1493 "sieve/sieve.y"
                                 { (yyval.test) = build_ihave(sscript, (yyvsp[0].sl)); }
#line 3953 "sieve/sieve.c"
    break;

  case 187: /* test: MAILBOXEXISTS stringlist  */
#line 1496 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_MAILBOXEXISTS, sscript);
                                     (yyval.test) = build_mbox_meta(sscript,
                                                          (yyval.test), NULL, NULL, (yyvsp[0].sl));
                                 }
#line 3963 "sieve/sieve.c"
    break;

  case 188: /* $@1: %empty  */
#line 1502 "sieve/sieve.y"
                   { bctype = BC_METADATA; }
#line 3969 "sieve/sieve.c"
    break;

  case 189: /* test: METADATA $@1 mtags string string stringlist  */
#line 1503 "sieve/sieve.y"
                                 { (yyval.test) = build_mbox_meta(sscript,
                                                        (yyvsp[-3].test), (yyvsp[-2].sval), (yyvsp[-1].sval), (yyvsp[0].sl)); }
#line 3976 "sieve/sieve.c"
    break;

  case 190: /* test: METADATAEXISTS string stringlist  */
#line 1507 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_METADATAEXISTS, sscript);
                                     (yyval.test) = build_mbox_meta(sscript,
                                                          (yyval.test), (yyvsp[-1].sval), NULL, (yyvsp[0].sl));
                                 }
#line 3986 "sieve/sieve.c"
    break;

  case 191: /* $@2: %empty  */
#line 1513 "sieve/sieve.y"
                         { bctype = BC_SERVERMETADATA; }
#line 3992 "sieve/sieve.c"
    break;

  case 192: /* test: SERVERMETADATA $@2 mtags string stringlist  */
#line 1514 "sieve/sieve.y"
                                 { (yyval.test) = build_mbox_meta(sscript,
                                                        (yyvsp[-2].test), NULL, (yyvsp[-1].sval), (yyvsp[0].sl)); }
#line 3999 "sieve/sieve.c"
    break;

  case 193: /* test: SERVERMETADATAEXISTS stringlist  */
#line 1518 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_SERVERMETADATAEXISTS,
                                                   sscript);
                                     (yyval.test) = build_mbox_meta(sscript,
                                                          (yyval.test), NULL, NULL, (yyvsp[0].sl));
                                 }
#line 4010 "sieve/sieve.c"
    break;

  case 194: /* test: VALIDEXTLIST stringlist  */
#line 1526 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_VALIDEXTLIST, sscript);
                                     (yyval.test)->u.sl = (yyvsp[0].sl);
                                     (yyval.test)->nargs = bc_precompile((yyval.test)->args, "S",
                                                               (yyval.test)->u.sl);
                                 }
#line 4021 "sieve/sieve.c"
    break;

  case 195: /* test: DUPLICATE duptags  */
#line 1532 "sieve/sieve.y"
                                 { (yyval.test) = build_duplicate(sscript, (yyvsp[0].test)); }
#line 4027 "sieve/sieve.c"
    break;

  case 196: /* test: SPECIALUSEEXISTS stringlist  */
#line 1535 "sieve/sieve.y"
                                 { 
                                     (yyval.test) = new_test(BC_SPECIALUSEEXISTS, sscript);
                                     (yyval.test) = build_mbox_meta(sscript,
                                                          (yyval.test), NULL, NULL, (yyvsp[0].sl));
                                 }
#line 4037 "sieve/sieve.c"
    break;

  case 197: /* test: SPECIALUSEEXISTS string stringlist  */
#line 1542 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_SPECIALUSEEXISTS, sscript);
                                     (yyval.test) = build_mbox_meta(sscript,
                                                          (yyval.test), (yyvsp[-1].sval), NULL, (yyvsp[0].sl));
                                 }
#line 4047 "sieve/sieve.c"
    break;

  case 198: /* test: MAILBOXIDEXISTS stringlist  */
#line 1549 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_MAILBOXIDEXISTS, sscript);
                                     (yyval.test) = build_mbox_meta(sscript,
                                                          (yyval.test), NULL, NULL, (yyvsp[0].sl));
                                 }
#line 4057 "sieve/sieve.c"
    break;

  case 199: /* test: JMAPQUERY string  */
#line 1555 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_JMAPQUERY, sscript);
                                     (yyval.test) = build_jmapquery(sscript, (yyval.test), (yyvsp[0].sval));
                                 }
#line 4066 "sieve/sieve.c"
    break;

  case 200: /* test: error  */
#line 1560 "sieve/sieve.y"
                                 { (yyval.test) = new_test(BC_FALSE, sscript); }
#line 4072 "sieve/sieve.c"
    break;

  case 201: /* sizetag: OVER  */
#line 1565 "sieve/sieve.y"
                                 { (yyval.nval) = B_OVER;  }
#line 4078 "sieve/sieve.c"
    break;

  case 202: /* sizetag: UNDER  */
#line 1566 "sieve/sieve.y"
                                 { (yyval.nval) = B_UNDER; }
#line 4084 "sieve/sieve.c"
    break;

  case 203: /* htags: %empty  */
#line 1571 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_HEADER, sscript);
                                     ctags = &((yyval.test)->u.hhs.comp);
                                 }
#line 4093 "sieve/sieve.c"
    break;

  case 208: /* matchtype: matchtag  */
#line 1583 "sieve/sieve.y"
                                 {
                                     /* *ctags assigned by the calling rule */
                                     if (ctags->match != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MULTIPLE_TAGS,
                                                      "match-type");
                                     }

                                     ctags->match = (yyvsp[0].nval);
                                 }
#line 4108 "sieve/sieve.c"
    break;

  case 209: /* matchtype: relmatch relation  */
#line 1594 "sieve/sieve.y"
                                 {
                                     if (ctags->match != B_COUNT &&
                                         ctags->match != B_VALUE &&
                                         !supported(SIEVE_CAPA_RELATIONAL)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "relational");
                                     }
                                     if (ctags->match != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MULTIPLE_TAGS,
                                                      "match-type");
                                     }

                                     ctags->match = (yyvsp[-1].nval);
                                     ctags->relation = (yyvsp[0].nval);
                                 }
#line 4130 "sieve/sieve.c"
    break;

  case 210: /* matchtag: IS  */
#line 1615 "sieve/sieve.y"
                                 { (yyval.nval) = B_IS;       }
#line 4136 "sieve/sieve.c"
    break;

  case 211: /* matchtag: CONTAINS  */
#line 1616 "sieve/sieve.y"
                                 { (yyval.nval) = B_CONTAINS; }
#line 4142 "sieve/sieve.c"
    break;

  case 212: /* matchtag: MATCHES  */
#line 1617 "sieve/sieve.y"
                                 { (yyval.nval) = B_MATCHES;  }
#line 4148 "sieve/sieve.c"
    break;

  case 213: /* matchtag: REGEX  */
#line 1618 "sieve/sieve.y"
                                 {
                                     if (!supported(SIEVE_CAPA_REGEX)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "regex");
                                     }

                                     (yyval.nval) = B_REGEX;
                                 }
#line 4162 "sieve/sieve.c"
    break;

  case 214: /* relmatch: COUNT  */
#line 1631 "sieve/sieve.y"
                                 { (yyval.nval) = B_COUNT; }
#line 4168 "sieve/sieve.c"
    break;

  case 215: /* relmatch: VALUE  */
#line 1632 "sieve/sieve.y"
                                 { (yyval.nval) = B_VALUE; }
#line 4174 "sieve/sieve.c"
    break;

  case 216: /* relation: EQ  */
#line 1637 "sieve/sieve.y"
                                 { (yyval.nval) = B_EQ; }
#line 4180 "sieve/sieve.c"
    break;

  case 217: /* relation: NE  */
#line 1638 "sieve/sieve.y"
                                 { (yyval.nval) = B_NE; }
#line 4186 "sieve/sieve.c"
    break;

  case 218: /* relation: GT  */
#line 1639 "sieve/sieve.y"
                                 { (yyval.nval) = B_GT; }
#line 4192 "sieve/sieve.c"
    break;

  case 219: /* relation: GE  */
#line 1640 "sieve/sieve.y"
                                 { (yyval.nval) = B_GE; }
#line 4198 "sieve/sieve.c"
    break;

  case 220: /* relation: LT  */
#line 1641 "sieve/sieve.y"
                                 { (yyval.nval) = B_LT; }
#line 4204 "sieve/sieve.c"
    break;

  case 221: /* relation: LE  */
#line 1642 "sieve/sieve.y"
                                 { (yyval.nval) = B_LE; }
#line 4210 "sieve/sieve.c"
    break;

  case 222: /* listmatch: LIST  */
#line 1647 "sieve/sieve.y"
                                 {
                                     /* *ctags assigned by the calling rule */
                                     if (ctags->match != B_LIST &&
                                         !supported(SIEVE_CAPA_EXTLISTS)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "extlists");
                                     }
                                     if (ctags->match != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MULTIPLE_TAGS,
                                                      "match-type");
                                     }

                                     ctags->match = B_LIST;
                                 }
#line 4231 "sieve/sieve.c"
    break;

  case 223: /* comparator: COMPARATOR collation  */
#line 1668 "sieve/sieve.y"
                                 {
                                     /* *ctags assigned by the calling rule */
                                     if (ctags->collation != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":comparator");
                                     }

                                     ctags->collation = (yyvsp[0].nval);
                                 }
#line 4246 "sieve/sieve.c"
    break;

  case 224: /* collation: OCTET  */
#line 1682 "sieve/sieve.y"
                                 { (yyval.nval) = B_OCTET;        }
#line 4252 "sieve/sieve.c"
    break;

  case 225: /* collation: ASCIICASEMAP  */
#line 1683 "sieve/sieve.y"
                                 { (yyval.nval) = B_ASCIICASEMAP; }
#line 4258 "sieve/sieve.c"
    break;

  case 226: /* collation: ASCIINUMERIC  */
#line 1684 "sieve/sieve.y"
                                 {
                                     if (!supported(SIEVE_CAPA_COMP_NUMERIC)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "comparator-"
                                                      "i;ascii-numeric");
                                     }

                                     (yyval.nval) = B_ASCIINUMERIC;
                                 }
#line 4273 "sieve/sieve.c"
    break;

  case 227: /* indexext: index  */
#line 1698 "sieve/sieve.y"
                                 {
                                     /* *ctags assigned by the calling rule */
                                     if (ctags->index != 0 &&
                                         !supported(SIEVE_CAPA_INDEX)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "index");
                                     }
                                 }
#line 4287 "sieve/sieve.c"
    break;

  case 228: /* index: INDEX NUMBER  */
#line 1709 "sieve/sieve.y"
                                 {
                                     /* *ctags assigned by the calling rule */
                                     if (ctags->index == INT_MIN) {
                                         /* parsed :last before :index */
                                         ctags->index = -(yyvsp[0].nval);
                                     }
                                     else if (ctags->index != 0) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":index");
                                     }
                                     else {
                                         ctags->index = (yyvsp[0].nval);
                                     }
                                 }
#line 4307 "sieve/sieve.c"
    break;

  case 229: /* index: LAST  */
#line 1724 "sieve/sieve.y"
                                 {
                                     if (ctags->index > 0) {
                                         ctags->index *= -1;
                                     }
                                     else if (ctags->index < 0) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":last");
                                     }
                                     else {
                                         /* special value to indicate that
                                            we parsed :last before :index */
                                         ctags->index = INT_MIN;
                                     }
                                 }
#line 4327 "sieve/sieve.c"
    break;

  case 230: /* atags: %empty  */
#line 1743 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_ADDRESS, sscript);
                                     ctags = &((yyval.test)->u.ae.comp);
                                 }
#line 4336 "sieve/sieve.c"
    break;

  case 236: /* addrpart: addrparttag  */
#line 1756 "sieve/sieve.y"
                                {
                                     /* $0 refers to a test_t* (ADDR/ENV)*/
                                     test_t *test = (yyvsp[-1].test);

                                     if (test->u.ae.addrpart != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MULTIPLE_TAGS,
                                                      "address-part");
                                     }

                                     test->u.ae.addrpart = (yyvsp[0].nval);
                                 }
#line 4353 "sieve/sieve.c"
    break;

  case 237: /* addrparttag: ALL  */
#line 1771 "sieve/sieve.y"
                                 { (yyval.nval) = B_ALL;       }
#line 4359 "sieve/sieve.c"
    break;

  case 238: /* addrparttag: LOCALPART  */
#line 1772 "sieve/sieve.y"
                                 { (yyval.nval) = B_LOCALPART; }
#line 4365 "sieve/sieve.c"
    break;

  case 239: /* addrparttag: DOMAIN  */
#line 1773 "sieve/sieve.y"
                                 { (yyval.nval) = B_DOMAIN;    }
#line 4371 "sieve/sieve.c"
    break;

  case 240: /* addrparttag: subaddress  */
#line 1774 "sieve/sieve.y"
                                 {
                                     if (!supported(SIEVE_CAPA_SUBADDRESS)) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MISSING_REQUIRE,
                                                      "subaddress");
                                     }
                                 }
#line 4383 "sieve/sieve.c"
    break;

  case 241: /* subaddress: USER  */
#line 1785 "sieve/sieve.y"
                                 { (yyval.nval) = B_USER;   }
#line 4389 "sieve/sieve.c"
    break;

  case 242: /* subaddress: DETAIL  */
#line 1786 "sieve/sieve.y"
                                 { (yyval.nval) = B_DETAIL; }
#line 4395 "sieve/sieve.c"
    break;

  case 243: /* etags: %empty  */
#line 1791 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_ENVELOPE, sscript);
                                     ctags = &((yyval.test)->u.ae.comp);
                                 }
#line 4404 "sieve/sieve.c"
    break;

  case 248: /* envtags: %empty  */
#line 1803 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_ENVIRONMENT, sscript);
                                     ctags = &((yyval.test)->u.mm.comp);
                                 }
#line 4413 "sieve/sieve.c"
    break;

  case 251: /* btags: %empty  */
#line 1813 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_BODY, sscript);
                                     ctags = &((yyval.test)->u.b.comp);
                                 }
#line 4422 "sieve/sieve.c"
    break;

  case 252: /* btags: btags transform  */
#line 1817 "sieve/sieve.y"
                                 {
                                     if ((yyval.test)->u.b.transform != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MULTIPLE_TAGS,
                                                      "transform");
                                     }

                                     (yyval.test)->u.b.transform = (yyvsp[0].nval);
                                 }
#line 4436 "sieve/sieve.c"
    break;

  case 253: /* btags: btags CONTENT stringlist  */
#line 1828 "sieve/sieve.y"
                                 {
                                     if ((yyval.test)->u.b.transform != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_MULTIPLE_TAGS,
                                                      "transform");
                                         strarray_free((yyval.test)->u.b.content_types);
                                     }

                                     (yyval.test)->u.b.transform = B_CONTENT;
                                     (yyval.test)->u.b.content_types = (yyvsp[0].sl);
                                 }
#line 4452 "sieve/sieve.c"
    break;

  case 256: /* transform: RAW  */
#line 1846 "sieve/sieve.y"
                                 { (yyval.nval) = B_RAW;  }
#line 4458 "sieve/sieve.c"
    break;

  case 257: /* transform: TEXT  */
#line 1847 "sieve/sieve.y"
                                 { (yyval.nval) = B_TEXT; }
#line 4464 "sieve/sieve.c"
    break;

  case 258: /* strtags: %empty  */
#line 1852 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_STRING, sscript);
                                     ctags = &((yyval.test)->u.hhs.comp);
                                 }
#line 4473 "sieve/sieve.c"
    break;

  case 262: /* hftags: %empty  */
#line 1863 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_HASFLAG, sscript);
                                     ctags = &((yyval.test)->u.hhs.comp);
                                 }
#line 4482 "sieve/sieve.c"
    break;

  case 265: /* dttags: %empty  */
#line 1873 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_DATE, sscript);
                                     ctags = &((yyval.test)->u.dt.comp);
                                 }
#line 4491 "sieve/sieve.c"
    break;

  case 267: /* dttags: dttags ORIGINALZONE  */
#line 1878 "sieve/sieve.y"
                                 {
                                     if ((yyval.test)->u.dt.zone.tag != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":originalzone");
                                     }

                                     (yyval.test)->u.dt.zone.tag = B_ORIGINALZONE;
                                 }
#line 4505 "sieve/sieve.c"
    break;

  case 271: /* zone: ZONE string  */
#line 1894 "sieve/sieve.y"
                                 {
                                     /* $0 refers to a test_t* ([CURRENT]DATE)*/
                                     test_t *test = (yyvsp[-2].test);

                                     if (test->u.dt.zone.tag != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":zone");
                                     }

                                     test->u.dt.zone.tag = B_TIMEZONE;
                                     test->u.dt.zone.offset = (yyvsp[0].sval);
                                 }
#line 4523 "sieve/sieve.c"
    break;

  case 272: /* cdtags: %empty  */
#line 1911 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_CURRENTDATE, sscript);
                                     ctags = &((yyval.test)->u.dt.comp);
                                 }
#line 4532 "sieve/sieve.c"
    break;

  case 276: /* methtags: %empty  */
#line 1922 "sieve/sieve.y"
                                 {
                                     (yyval.test) = new_test(BC_NOTIFYMETHODCAPABILITY,
                                                   sscript);
                                     ctags = &((yyval.test)->u.mm.comp);
                                 }
#line 4542 "sieve/sieve.c"
    break;

  case 279: /* mtags: %empty  */
#line 1933 "sieve/sieve.y"
                                 {
                                     /* bctype assigned by the calling rule */
                                     (yyval.test) = new_test(bctype, sscript);
                                     ctags = &((yyval.test)->u.mm.comp);
                                 }
#line 4552 "sieve/sieve.c"
    break;

  case 282: /* duptags: %empty  */
#line 1944 "sieve/sieve.y"
                                 { (yyval.test) = new_test(BC_DUPLICATE, sscript); }
#line 4558 "sieve/sieve.c"
    break;

  case 283: /* duptags: duptags idtype string  */
#line 1945 "sieve/sieve.y"
                                 {
                                     if ((yyval.test)->u.dup.idtype != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_CONFLICTING_TAGS,
                                                      ":header", ":uniqueid");
                                         free((yyval.test)->u.dup.idval);
                                     }

                                     (yyval.test)->u.dup.idtype = (yyvsp[-1].nval);
                                     (yyval.test)->u.dup.idval = (yyvsp[0].sval);
                                 }
#line 4574 "sieve/sieve.c"
    break;

  case 284: /* duptags: duptags HANDLE string  */
#line 1956 "sieve/sieve.y"
                                 {
                                     if ((yyval.test)->u.dup.handle != NULL) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":handle");
                                         free((yyval.test)->u.dup.handle);
                                     }

                                     (yyval.test)->u.dup.handle = (yyvsp[0].sval);
                                 }
#line 4589 "sieve/sieve.c"
    break;

  case 285: /* duptags: duptags SECONDS NUMBER  */
#line 1966 "sieve/sieve.y"
                                 {
                                     if ((yyval.test)->u.dup.seconds != -1) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":seconds");
                                     }

                                     (yyval.test)->u.dup.seconds = (yyvsp[0].nval);
                                 }
#line 4603 "sieve/sieve.c"
    break;

  case 286: /* duptags: duptags LAST  */
#line 1975 "sieve/sieve.y"
                                 {
                                     if ((yyval.test)->u.dup.last != 0) {
                                         sieveerror_c(sscript,
                                                      SIEVE_DUPLICATE_TAG,
                                                      ":last");
                                     }

                                     (yyval.test)->u.dup.last = 1;
                                 }
#line 4617 "sieve/sieve.c"
    break;

  case 287: /* idtype: HEADER  */
#line 1988 "sieve/sieve.y"
                                 { (yyval.nval) = B_HEADER;   }
#line 4623 "sieve/sieve.c"
    break;

  case 288: /* idtype: UNIQUEID  */
#line 1989 "sieve/sieve.y"
                                 { (yyval.nval) = B_UNIQUEID; }
#line 4629 "sieve/sieve.c"
    break;


#line 4633 "sieve/sieve.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (sscript, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, sscript);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, sscript);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (sscript, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, sscript);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, sscript);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1993 "sieve/sieve.y"



/*
 * Yacc actions
 */

void yyerror(sieve_script_t *sscript, const char *msg)
{
    if (sscript->ignore_err) return;

    sscript->err++;
    if (sscript->interp.err) {
        sscript->interp.err(sievelineno, msg, sscript->interp.interp_context,
                            sscript->script_context);
    }
}


static void
__attribute__((format(printf, 2, 0)))
vsieveerror_f(sieve_script_t *sscript,
              const char *fmt, va_list args)
{
    buf_reset(&sscript->sieveerr);
    buf_vprintf(&sscript->sieveerr, fmt, args);
    yyerror(sscript, buf_cstring(&sscript->sieveerr));
}

void
__attribute__((format(printf, 2, 3)))
sieveerror_f(sieve_script_t *sscript, const char *fmt, ...)
{
    va_list args;

    va_start(args, fmt);
    vsieveerror_f(sscript, fmt, args);
    va_end(args);
}

void sieveerror_c(sieve_script_t *sscript, int code, ...)
{
    va_list args;

    va_start(args, code);
    vsieveerror_f(sscript, error_message(code), args);
    va_end(args);
}

/*
 * variable-ref        =  "${" [namespace] variable-name "}"
 * namespace           =  identifier "." *sub-namespace
 * sub-namespace       =  variable-name "."
 * variable-name       =  num-variable / identifier
 * num-variable        =  1*DIGIT
 * identifier          =  (ALPHA / "_") *(ALPHA / DIGIT / "_")
 */
static int find_variables(sieve_script_t *sscript, char *s, int find_one)
{
    char *p = s;

    if (!supported(SIEVE_CAPA_VARIABLES)) return !find_one;

    while ((p = strstr(p, "${"))) {
        long num = 0, is_id = 0;

        p += 2;  /* skip over beginning of variable-ref */

        do {
            if (isdigit(*p)) {
                /* possible num-variable - get value and skip over digits */
                num = strtol(p, &p, 10);
            }
            else if (!find_one) {
                /* validating match variables - ignoroe identifiers */
                break;
            }
            else if (isalpha(*p) || *p == '_') {
                /* possible identifier - skip over identifier chars */
                for (++p; isalnum(*p) || *p == '_'; p++);
                is_id = 1;
            }
            else {
                /* not a valid variable-name */
                break;
            }

            if (*p == '}') {
                /* end of variable-ref */
                if (find_one) return 1;

                /* validating match variables */
                if (!is_id && num > MAX_MATCH_VARS) {
                    sieveerror_f(sscript, "string '%s':"
                                 " match variable index > %u unsupported",
                                 s, MAX_MATCH_VARS);
                    return 0;
                }
            }

        } while (is_id && *p == '.' && *(++p));  /* (sub-)namespace */
    }

    return !find_one;
}

static int chk_match_vars(sieve_script_t *sscript, char *s)
{
    return find_variables(sscript, s, 0 /* find_one */);
}

static int contains_variable(sieve_script_t *sscript, char *s)
{
    return find_variables(sscript, s, 1 /* find_one */);
}

/*
 * Valid UTF-8 check (from RFC 2640 Annex B.1)
 *
 * The following routine checks if a byte sequence is valid UTF-8. This
 * is done by checking for the proper tagging of the first and following
 * bytes to make sure they conform to the UTF-8 format. It then checks
 * to assure that the data part of the UTF-8 sequence conforms to the
 * proper range allowed by the encoding. Note: This routine will not
 * detect characters that have not been assigned and therefore do not
 * exist.
 */
static int verify_utf8(sieve_script_t *sscript, char *s)
{
    const char *buf = s;
    const char *endbuf = s + strlen(s);
    unsigned char byte2mask = 0x00, c;
    int trailing = 0;  /* trailing (continuation) bytes to follow */

    while (buf != endbuf) {
        c = *buf++;
        if (trailing) {
            if ((c & 0xC0) == 0x80) {           /* Does trailing byte
                                                   follow UTF-8 format? */
                if (byte2mask) {                /* Need to check 2nd byte
                                                   for proper range? */
                    if (c & byte2mask)          /* Are appropriate bits set? */
                        byte2mask = 0x00;
                    else
                        break;
                }
                trailing--;
            }
            else
                break;
        }
        else {
            if ((c & 0x80) == 0x00)             /* valid 1 byte UTF-8 */
                continue;
            else if ((c & 0xE0) == 0xC0)        /* valid 2 byte UTF-8 */
                if (c & 0x1E) {                 /* Is UTF-8 byte
                                                   in proper range? */
                    trailing = 1;
                }
                else
                    break;
            else if ((c & 0xF0) == 0xE0) {      /* valid 3 byte UTF-8 */
                if (!(c & 0x0F)) {              /* Is UTF-8 byte
                                                   in proper range? */
                    byte2mask = 0x20;           /* If not, set mask
                                                   to check next byte */
                }
                trailing = 2;
            }
            else if ((c & 0xF8) == 0xF0) {      /* valid 4 byte UTF-8 */
                if (!(c & 0x07)) {              /* Is UTF-8 byte
                                                   in proper range? */
                    byte2mask = 0x30;           /* If not, set mask
                                                   to check next byte */
                }
                trailing = 3;
            }
            else if ((c & 0xFC) == 0xF8) {      /* valid 5 byte UTF-8 */
                if (!(c & 0x03)) {              /* Is UTF-8 byte
                                                   in proper range? */
                    byte2mask = 0x38;           /* If not, set mask
                                                   to check next byte */
                }
                trailing = 4;
            }
            else if ((c & 0xFE) == 0xFC) {      /* valid 6 byte UTF-8 */
                if (!(c & 0x01)) {              /* Is UTF-8 byte
                                                   in proper range? */
                    byte2mask = 0x3C;           /* If not, set mask
                                                   to check next byte */
                }
                trailing = 5;
            }
            else
                break;
        }
    }

    if ((buf != endbuf) || trailing) {
        sieveerror_f(sscript, "string '%s': not valid utf8", s);
        return 0;
    }

    return 1;
}

static int verify_stringlist(sieve_script_t *sscript, strarray_t *sa,
                             int (*verify)(sieve_script_t*, char *))
{
    int i;

    for (i = 0 ; i < strarray_size(sa) ; i++) {
        if (!verify(sscript, (char *) strarray_nth(sa, i))) return 0;
    }
    return 1;
}

#ifdef ENABLE_REGEX
static int verify_regexlist(sieve_script_t *sscript,
                            const strarray_t *sa, int collation)
{
    int i, ret = 0;
    int cflags = REG_EXTENDED | REG_NOSUB;

    /* support UTF8 comparisons */
#if defined HAVE_PCREPOSIX_H
    cflags |= REG_UTF8;
#elif defined HAVE_PCRE2POSIX_H
    cflags |= REG_UTF;
#endif

    if (collation == B_ASCIICASEMAP) {
        cflags |= REG_ICASE;
    }

    for (i = 0 ; !ret && i < strarray_size(sa) ; i++) {
        const char *s = strarray_nth(sa, i);
        regex_t reg = {0};

        /* Don't try to validate a regex that includes variables */
        if (supported(SIEVE_CAPA_VARIABLES) && strstr(s, "${")) continue;

        /* Check if the regex will compile */
        if ((ret = regcomp(&reg, s, cflags)) != 0) {
            size_t errbuf_size = regerror(ret, &reg, NULL, 0);

            buf_reset(&sscript->sieveerr);
            buf_ensure(&sscript->sieveerr, errbuf_size);
            (void) regerror(ret, &reg,
                            (char *) buf_base(&sscript->sieveerr),
                            errbuf_size);
            buf_truncate(&sscript->sieveerr, errbuf_size);
            yyerror(sscript, buf_cstring(&sscript->sieveerr));
        }

        regfree(&reg);
    }

    return (ret == 0);
}
#else

static int verify_regexlist(sieve_script_t *sscript __attribute__((unused)),
                            const strarray_t *sa __attribute__((unused)),
                            char *comp __attribute__((unused)))
{
    return 0;
}
#endif /* ENABLE_REGEX */

static int verify_patternlist(sieve_script_t *sscript,
                              strarray_t *sa, comp_t *c,
                              int (*verify)(sieve_script_t*, char *))
{
    if (verify && !verify_stringlist(sscript, sa, verify)) return 0;

    canon_comptags(c, sscript);

    return (c->match == B_REGEX) ?
        verify_regexlist(sscript, sa, c->collation) : 1;
}

static int verify_address(sieve_script_t *sscript, char *s)
{
    if (contains_variable(sscript, s)) return 1;

    YY_BUFFER_STATE buffer = addr_scan_string(s);
    int r = 1;

    sscript->addrerr[0] = '\0';    /* paranoia */
    if (addrparse(sscript)) {
        sieveerror_f(sscript, "address '%s': %s", s, sscript->addrerr);
        r = 0;
    }
    addr_delete_buffer(buffer);

    return r;
}

static int verify_mailbox(sieve_script_t *sscript, char *s)
{
    if (!verify_utf8(sscript, s)) {
        sieveerror_f(sscript, "mailbox '%s': not a valid mailbox", s);
        return 0;
    }

    return 1;
}

static int verify_header(sieve_script_t *sscript, char *hdr)
{
    char *h = hdr;

    while (*h) {
        /* field-name      =       1*ftext
           ftext           =       %d33-57 / %d59-126
           ; Any character except
           ;  controls, SP, and
           ;  ":". */
        if (!((*h >= 33 && *h <= 57) || (*h >= 59 && *h <= 126))) {
            sieveerror_f(sscript, "header '%s': not a valid header", hdr);
            return 0;
        }
        h++;
    }
    return 1;
}

static int verify_addrheader(sieve_script_t *sscript, char *hdr)
{
    const char **h, *hdrs[] = {
        "from", "sender", "reply-to",   /* RFC 5322 originator fields */
        "to", "cc", "bcc",              /* RFC 5322 destination fields */
        "message-id", "in-reply-to",    /* RFC 5322 identification fields */
        "references",
        "resent-from", "resent-sender", /* RFC 5322 resent fields */
        "resent-to", "resent-cc", "resent-bcc",
        "return-path",                  /* RFC 5322 trace fields */
        "disposition-notification-to",  /* RFC 8098 MDN request fields */
        "approved",                     /* RFC 5536 moderator/control fields */
        "delivered-to",                 /* non-standard (loop detection) */
        NULL
    };

    if (contains_variable(sscript, hdr)) return 1;

    if (!config_getswitch(IMAPOPT_RFC3028_STRICT))
        return verify_header(sscript, hdr);

    for (lcase(hdr), h = hdrs; *h; h++) {
        if (!strcmp(*h, hdr)) return 1;
    }

    sieveerror_f(sscript,
                 "header '%s': not a valid header for an address test", hdr);
    return 0;
}

static int verify_envelope(sieve_script_t *sscript, char *env)
{
    if (contains_variable(sscript, env)) return 1;

    lcase(env);
    if (!config_getswitch(IMAPOPT_RFC3028_STRICT) ||
        !strcmp(env, "from") || !strcmp(env, "to") || !strcmp(env, "auth")) {
        return 1;
    }

    sieveerror_f(sscript,
                 "env-part '%s': not a valid part for an envelope test", env);
    return 0;
}

static int verify_list(sieve_script_t *sscript, char *s)
{
    if (sscript->interp.isvalidlist &&
        sscript->interp.isvalidlist(sscript->interp.interp_context, s)
        != SIEVE_OK) {
        sieveerror_f(sscript, "list '%s': is not valid/supported", s);
        return 0;
    }

    return 1;
}

static int check_reqs(sieve_script_t *sscript, strarray_t *sa)
{
    char *s;
    struct buf *errs = &sscript->sieveerr;
    int ret = 1, sep = ':';

    buf_setcstr(errs, "Unsupported feature(s) in \"require\"");
    while ((s = strarray_shift(sa))) {
        if (!script_require(sscript, s)) {
            buf_printf(errs, "%c \"%s\"", sep, s);
            ret = 0;
            sep = ',';
        }
        free(s);
    }
    strarray_free(sa);

    if (ret == 0) yyerror(sscript, buf_cstring(&sscript->sieveerr));
    else if (supported(SIEVE_CAPA_IHAVE)) {
        /* mark all allowed extensions as supported */
        sscript->support |= (SIEVE_CAPA_ALL & ~SIEVE_CAPA_IHAVE_INCOMPAT);
    }

    encoded_char = supported(SIEVE_CAPA_ENCODED_CHAR);

    return ret;
}

/* take a format string and a variable list of arguments
   and populate the command arguments array */
static unsigned bc_precompile(cmdarg_t args[], const char *fmt, ...)
{
    va_list ap;
    unsigned n = 0;

    va_start(ap, fmt);
    for (n = 0; *fmt; fmt++, n++) {
        args[n].type = *fmt;

        switch (*fmt) {
        case 'i':
            args[n].u.i = va_arg(ap, int);
            break;
        case 's':
            args[n].u.s = va_arg(ap, const char *);
            break;
        case 'S':
            args[n].u.sa = va_arg(ap, const strarray_t *);
            break;
        case 'U':
            args[n].u.ua = va_arg(ap, const arrayu64_t *);
            break;
        case 't':
            args[n].u.t = va_arg(ap, const test_t *);
            break;
        case 'T':
            args[n].u.tl = va_arg(ap, const testlist_t *);
            break;
        case 'C': {
            /* Expand the comparator into its component parts */
            const comp_t *c = va_arg(ap, const comp_t *);

            args[n].type = AT_INT;
            args[n].u.i = c->match;
            args[++n].type = AT_INT;
            args[n].u.i = c->relation;
            args[++n].type = AT_INT;
            args[n].u.i = c->collation;
            break;
        }
        case 'Z': {
            /* Expand the zone into its component parts */
            const zone_t *z = va_arg(ap, const zone_t *);

            args[n].type = AT_INT;
            args[n].u.i = z->tag;

            if (z->tag == B_TIMEZONE) {
                args[++n].type = AT_STR;
                args[n].u.s = z->offset;
            }
            break;
        }
        default: assert(*fmt);
        }
    }
    va_end(ap);

    return n;
}

static commandlist_t *build_keep(sieve_script_t *sscript, commandlist_t *c)
{
    assert(c && c->type == B_KEEP);

    if (c->u.k.flags && !_verify_flaglist(c->u.k.flags)) {
        strarray_add(c->u.k.flags, "");
    }

    c->nargs = bc_precompile(c->args, "S", c->u.k.flags);

    return c;
}

static commandlist_t *build_fileinto(sieve_script_t *sscript,
                                     commandlist_t *c, char *folder)
{
    assert(c && c->type == B_FILEINTO);

    if (c->u.f.flags && !_verify_flaglist(c->u.f.flags)) {
        strarray_add(c->u.f.flags, "");
    }
    verify_mailbox(sscript, folder);
    c->u.f.folder = folder;

    c->nargs = bc_precompile(c->args, "ssiSis",
                             c->u.f.mailboxid,
                             c->u.f.specialuse,
                             c->u.f.create,
                             c->u.f.flags,
                             c->u.f.copy,
                             c->u.f.folder);

    return c;
}

static commandlist_t *build_redirect(sieve_script_t *sscript,
                                     commandlist_t *c, char *address)
{
    assert(c && c->type == B_REDIRECT);

    if (c->u.r.list) verify_list(sscript, address);
    else verify_address(sscript, address);

    /* Verify DELIVERBY values */
    if (c->u.r.bytime) {
        if (!supported(SIEVE_CAPA_VARIABLES)) {
            time_t t;

            if (c->u.r.bytime[0] != '+' &&
                time_from_iso8601(c->u.r.bytime, &t) == -1) {
                sieveerror_f(sscript,
                             "string '%s': not a valid DELIVERBY time value",
                             c->u.r.bytime);
            }
            if (c->u.r.bymode &&
                strcasecmp(c->u.r.bymode, "NOTIFY") &&
                strcasecmp(c->u.r.bymode, "RETURN")) {
                sieveerror_f(sscript,
                             "string '%s': not a valid DELIVERBY mode value",
                             c->u.r.bymode);
            }
        }
    }
    else if (c->u.r.bymode || c->u.r.bytrace) {
        sieveerror_c(sscript, SIEVE_MISSING_TAG,
                     ":bytimerelative OR :bytimeabsolute");
    }

    /* Verify DSN NOTIFY value(s) */
    if (c->u.r.dsn_notify && !supported(SIEVE_CAPA_VARIABLES)) {
        tok_t tok =
            TOK_INITIALIZER(c->u.r.dsn_notify, ",", TOK_TRIMLEFT|TOK_TRIMRIGHT);
        char *token;
        int never = 0;

        while ((token = tok_next(&tok))) {
            if (!strcasecmp(token, "NEVER")) never = 1;
            else if (never) {
                sieveerror_f(sscript,
                             "DSN NOTIFY value 'NEVER' MUST be used by itself");
                break;
            }
            else if (strcasecmp(token, "SUCCESS") &&
                     strcasecmp(token, "FAILURE") &&
                     strcasecmp(token, "DELAY")) {
                sieveerror_f(sscript,
                             "string '%s': not a valid DSN NOTIFY value",
                             token);
                break;
            }
        }
        tok_fini(&tok);
    }

    /* Verify DSN RET value */
    if (c->u.r.dsn_ret && !supported(SIEVE_CAPA_VARIABLES) &&
        strcasecmp(c->u.r.dsn_ret, "FULL") &&
        strcasecmp(c->u.r.dsn_ret, "HDRS")) {
        sieveerror_f(sscript, "string '%s': not a valid DSN RET value",
                     c->u.r.dsn_ret);
    }

    c->u.r.address = address;

    c->nargs = bc_precompile(c->args, "ssissiis",
                             c->u.r.bytime,
                             c->u.r.bymode,
                             c->u.r.bytrace,
                             c->u.r.dsn_notify,
                             c->u.r.dsn_ret,
                             c->u.r.list,
                             c->u.r.copy,
                             c->u.r.address);

    return c;
}

static int verify_identifier(sieve_script_t *sscript, char *s)
{
    /* identifier         = (ALPHA / "_") *(ALPHA / DIGIT / "_") */

    if (!is_identifier(s)) {
        sieveerror_f(sscript,
                     "string '%s': not a valid sieve identifier", s);
        return 0;
    }
    return 1;
}

static commandlist_t *build_set(sieve_script_t *sscript,
                                commandlist_t *c, char *variable, char *value)
{
    assert(c && c->type == B_SET);

    verify_identifier(sscript, variable);
    verify_utf8(sscript, value);

    c->u.s.variable = variable;
    c->u.s.value = value;

    c->nargs = bc_precompile(c->args, "iss",
                             c->u.s.modifiers,
                             c->u.s.variable,
                             c->u.s.value);

    return c;
}

static commandlist_t *build_vacation(sieve_script_t *sscript,
                                     commandlist_t *c, char *message)
{
    int min = sscript->interp.vacation->min_response;
    int max = sscript->interp.vacation->max_response;

    assert(c && c->type == B_VACATION);

    if (c->u.v.handle) verify_utf8(sscript, c->u.v.handle);
    if (c->u.v.subject) verify_utf8(sscript, c->u.v.subject);
    if (c->u.v.from) verify_address(sscript, c->u.v.from);
    if (c->u.v.addresses)
        verify_stringlist(sscript, c->u.v.addresses, verify_address);
    if (c->u.v.mime == -1) {
        verify_utf8(sscript, message);
        c->u.v.mime = 0;
    }
    if (c->u.v.fcc.folder) {
        verify_mailbox(sscript, c->u.v.fcc.folder);
        if (c->u.v.fcc.flags && !_verify_flaglist(c->u.v.fcc.flags)) {
            strarray_add(c->u.v.fcc.flags, "");
        }
    }
    else if (c->u.v.fcc.create || c->u.v.fcc.flags ||
             c->u.v.fcc.specialuse || c->u.v.fcc.mailboxid) {
        sieveerror_c(sscript, SIEVE_MISSING_TAG, ":fcc");
    }

    c->u.v.message = message;

    if (c->u.v.seconds == -1) c->u.v.seconds = 7 * DAY2SEC;
    if (c->u.v.seconds < min) c->u.v.seconds = min;
    if (c->u.v.seconds > max) c->u.v.seconds = max;

    c->nargs = bc_precompile(c->args,
                             c->u.v.fcc.folder ? "SssiisssiSss" : "Sssiisss",
                             c->u.v.addresses,
                             c->u.v.subject,
                             c->u.v.message,
                             c->u.v.seconds,
                             c->u.v.mime,
                             c->u.v.from,
                             c->u.v.handle,
                             c->u.v.fcc.folder,
                             c->u.v.fcc.create,
                             c->u.v.fcc.flags,
                             c->u.v.fcc.specialuse,
                             c->u.v.fcc.mailboxid);

    return c;
}

static commandlist_t *build_flag(sieve_script_t *sscript,
                                 commandlist_t *c, strarray_t *flags)
{
    assert(c && (c->type == B_SETFLAG ||
                 c->type == B_ADDFLAG ||
                 c->type == B_REMOVEFLAG));

    if (!_verify_flaglist(flags)) {
        strarray_add(flags, "");
    }
    c->u.fl.flags = flags;

    if (!c->u.fl.variable) c->u.fl.variable = xstrdup("");
    else if (!is_identifier(c->u.fl.variable)) {
        sieveerror_c(sscript, SIEVE_INVALID_VALUE, "variablename");
    }

    c->nargs = bc_precompile(c->args, "sS",
                             c->u.fl.variable,
                             c->u.fl.flags);

    return c;
}

static commandlist_t *build_addheader(sieve_script_t *sscript,
                                      commandlist_t *c, char *name, char *value)
{
    assert(c && c->type == B_ADDHEADER);

    verify_header(sscript, name);
    verify_utf8(sscript, value);

    if (c->u.ah.index == 0) c->u.ah.index = 1;
    c->u.ah.name = name;
    c->u.ah.value = value;

    c->nargs = bc_precompile(c->args, "iss",
                             c->u.ah.index,
                             c->u.ah.name,
                             c->u.ah.value);

    return c;
}

static commandlist_t *build_deleteheader(sieve_script_t *sscript,
                                         commandlist_t *c,
                                         char *name, strarray_t *values)
{
    assert(c && c->type == B_DELETEHEADER);

    if (!strcasecmp("Received", name) || !strcasecmp("Auto-Submitted", name)) {
        sieveerror_f(sscript,
                     "MUST NOT delete Received or Auto-Submitted headers");
    }
    else if (c->u.dh.comp.index == INT_MIN) {
        sieveerror_c(sscript, SIEVE_MISSING_TAG, ":index");
    }

    verify_header(sscript, name);
    verify_patternlist(sscript, values, &c->u.dh.comp, verify_utf8);

    c->u.dh.name = name;
    c->u.dh.values = values;

    c->nargs = bc_precompile(c->args, "iCsS",
                             c->u.dh.comp.index,
                             &c->u.dh.comp,
                             c->u.dh.name,
                             c->u.dh.values);

    return c;
}

static int verify_weekday(sieve_script_t *sscript, char *day)
{
    int n = day[0] - '0';

    if (n >= 0 && n <= 6 && day[1] == '\0') {
        return (1 << n);
    }

    sieveerror_f(sscript, "'%s': not a valid weekday for snooze", day);
    return 0;
}

static int verify_time(sieve_script_t *sscript, char *time)
{
    struct tm tm;
    int t = 0;
    char *r = strptime(time, "%T", &tm);

    if (r && *r == '\0') {
        t = 3600 * tm.tm_hour + 60 * tm.tm_min + tm.tm_sec;
    }
    else {
        sieveerror_f(sscript, "'%s': not a valid time for snooze", time);
    }

    free(time);  /* done with this string */

    return t;
}

static commandlist_t *build_snooze(sieve_script_t *sscript,
                                   commandlist_t *c, arrayu64_t *times)
{
    assert(c && c->type == B_SNOOZE);

    if (c->u.sn.f.folder) verify_mailbox(sscript, c->u.sn.f.folder);
    if (c->u.sn.addflags && !_verify_flaglist(c->u.sn.addflags)) {
        strarray_add(c->u.sn.addflags, "");
    }
    if (c->u.sn.removeflags && !_verify_flaglist(c->u.sn.removeflags)) {
        strarray_add(c->u.sn.removeflags, "");
    }
    if (!c->u.sn.days) c->u.sn.days = 0x7f; /* all days */

    /* Sort times earliest -> latest */
    arrayu64_sort(times, NULL/*ascending*/);
    c->u.sn.times = times;

    c->nargs = bc_precompile(c->args, "sssiSSisU",
                             c->u.sn.f.folder,
                             c->u.sn.f.mailboxid,
                             c->u.sn.f.specialuse,
                             c->u.sn.f.create,
                             c->u.sn.addflags,
                             c->u.sn.removeflags,
                             c->u.sn.days,
                             c->u.sn.tzid,
                             c->u.sn.times);

    return c;
}

static commandlist_t *build_rej_err(sieve_script_t *sscript,
                                    int t, char *message)
{
    commandlist_t *c;

    assert(t == B_REJECT || t == B_EREJECT || t == B_ERROR);

    verify_utf8(sscript, message);

    c = new_command(t, sscript);
    c->u.str = message;

    c->nargs = bc_precompile(c->args, "s", c->u.str);

    return c;
}

static commandlist_t *build_notify(sieve_script_t *sscript, int t,
                                   commandlist_t *c, char *method)
{
    assert(c && (t == B_NOTIFY || t == B_ENOTIFY));

    if (t == B_ENOTIFY) {
        if (!supported(SIEVE_CAPA_ENOTIFY)) {
            sieveerror_c(sscript, SIEVE_MISSING_REQUIRE, "enotify");
        }
        if (c->u.n.id != NULL) {
            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":id");
        }
        if (c->u.n.method != NULL) {
            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":method");
        }
        if (c->u.n.fcc.folder) {
            verify_mailbox(sscript, c->u.n.fcc.folder);
            if (c->u.n.fcc.flags && !_verify_flaglist(c->u.n.fcc.flags)) {
                strarray_add(c->u.n.fcc.flags, "");
            }
        }
        else if (c->u.n.fcc.create || c->u.n.fcc.flags ||
                 c->u.n.fcc.specialuse || c->u.n.fcc.mailboxid) {
            sieveerror_c(sscript, SIEVE_MISSING_TAG, ":fcc");
        }

        c->u.n.method = method;
    }
    else {
        if (!supported(SIEVE_CAPA_NOTIFY)) {
            sieveerror_c(sscript, SIEVE_MISSING_REQUIRE, "notify");
        }
        if (c->u.n.from != NULL) {
            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":from");
        }
        if (c->u.n.fcc.folder != NULL) {
            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":fcc");
        }
        if (c->u.n.fcc.create != 0) {
            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":create");
        }
        if (c->u.n.fcc.flags != NULL) {
            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":flags");
        }
        if (c->u.n.fcc.specialuse != NULL) {
            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":specialuse");
        }

        if (!c->u.n.method) c->u.n.method = xstrdup("default");
    }

    c->type = t;
    if (c->u.n.priority == -1) c->u.n.priority = B_NORMAL;
    if (!c->u.n.message) c->u.n.message = xstrdup("$from$: $subject$");

    c->nargs = bc_precompile(c->args, "ssSis",
                             c->u.n.method,
                             (c->type == B_ENOTIFY) ? c->u.n.from : c->u.n.id,
                             c->u.n.options,
                             c->u.n.priority,
                             c->u.n.message);

    return c;
}

static commandlist_t *build_denotify(sieve_script_t *sscript,
                                     commandlist_t *t)
{
    assert(t && t->type == B_DENOTIFY);

    canon_comptags(&t->u.d.comp, sscript);

    if (t->u.d.priority == -1) t->u.d.priority = B_ANY;
    if (t->u.d.pattern) {
        strarray_t sa = STRARRAY_INITIALIZER;

        strarray_pushm(&sa, t->u.d.pattern);
        verify_patternlist(sscript, &sa, &t->u.d.comp, NULL);
        strarray_pop(&sa);
        strarray_fini(&sa);
    }

    t->nargs = bc_precompile(t->args, "iiis",
                             t->u.d.priority,
                             t->u.d.comp.match,
                             t->u.d.comp.relation,
                             t->u.d.pattern);

    return t;
}

static commandlist_t *build_include(sieve_script_t *sscript,
                                    commandlist_t *c, char *script)
{
    assert(c && c->type == B_INCLUDE);

    if (strchr(script, '/')) {
        sieveerror_c(sscript, SIEVE_INVALID_VALUE, "script-name");
    }

    c->u.inc.script = script;
    if (c->u.inc.once == -1) c->u.inc.once = 0;
    if (c->u.inc.location == -1) c->u.inc.location = B_PERSONAL;
    if (c->u.inc.optional == -1) c->u.inc.optional = 0;

    c->nargs = bc_precompile(c->args, "is",
                             c->u.inc.location |
                                 (c->u.inc.once | c->u.inc.optional),
                             c->u.inc.script);

    return c;
}

static commandlist_t *build_log(sieve_script_t *sscript, char *text)
{
    commandlist_t *c;

    verify_utf8(sscript, text);

    c = new_command(B_LOG, sscript);
    c->u.l.text = text;

    c->nargs = bc_precompile(c->args, "s", c->u.l.text);

    return c;
}

static commandlist_t *build_imip(sieve_script_t *sscript, commandlist_t *c)
{
    unsigned flags = 0;

    assert(c && c->type == B_PROCESSIMIP);

    if (c->u.imip.invites_only) flags |= IMIP_INVITESONLY;
    if (c->u.imip.updates_only) flags |= IMIP_UPDATESONLY;
    if (c->u.imip.delete_canceled) flags |= IMIP_DELETECANCELED;

    if (c->u.imip.outcome_var) verify_identifier(sscript, c->u.imip.outcome_var);
    if (c->u.imip.errstr_var) verify_identifier(sscript, c->u.imip.errstr_var);
    
    c->nargs = bc_precompile(c->args, "isss",
                             flags,
                             c->u.imip.calendarid,
                             c->u.imip.outcome_var,
                             c->u.imip.errstr_var);

    return c;
}

static test_t *build_anyof(sieve_script_t *sscript, testlist_t *tl)
{
    test_t *t;

    assert(tl);

    if (tl->next == NULL) {
        /* collapse single item list into a simple test */
        t = tl->t;
        free(tl);
    }
    else {
        test_t *fail = NULL, *maybe = NULL;

        /* create ANYOF test */
        t = new_test(BC_ANYOF, sscript);
        t->u.tl = tl;

        /* find first test that did/didn't set ignore_err */
        for ( ; tl && !fail && !maybe; tl = tl->next) {
            if (tl->t->ignore_err) {
                if (!fail) fail = tl->t;
            }
            else if (!maybe) maybe = tl->t;
        }

        if (fail) {
            if (maybe) {
                /* test may succeed - backout ignore_err */
                sscript->ignore_err = --fail->ignore_err;
            }
            else {
                /* test will fail - revert ignore_err to first value */
                sscript->ignore_err = t->ignore_err = fail->ignore_err;
            }
        }

        t->nargs = bc_precompile(t->args, "T", t->u.tl);
    }

    return t;
}

static test_t *build_allof(sieve_script_t *sscript, testlist_t *tl)
{
    test_t *t;

    assert(tl);

    if (tl->next == NULL) {
        /* collapse single item list into a simple test */
        t = tl->t;
        free(tl);
    }
    else {
        /* create ALLOF test */
        t = new_test(BC_ALLOF, sscript);
        t->u.tl = tl;

        /* find first test that set ignore_err and revert to that value */
        for ( ; tl; tl = tl->next) {
            if (tl->t->ignore_err) {
                sscript->ignore_err = t->ignore_err = tl->t->ignore_err;
                break;
            }
        }

        t->nargs = bc_precompile(t->args, "T", t->u.tl);
    }

    return t;
}

static test_t *build_not(sieve_script_t *sscript, test_t *t)
{
    test_t *n;

    assert(t);

    if (t->ignore_err) {
        /* test will succeed - backout ignore_err */
        sscript->ignore_err = --t->ignore_err;
    }

    n = new_test(BC_NOT, sscript);
    n->u.t = t;

    n->nargs = bc_precompile(n->args, "t", n->u.t);

    return n;
}

static test_t *build_hhs(sieve_script_t *sscript, test_t *t,
                         strarray_t *sl, strarray_t *pl)
{
    assert(t);

    verify_patternlist(sscript, pl, &t->u.hhs.comp, verify_utf8);

    t->u.hhs.sl = sl;
    t->u.hhs.pl = pl;

    t->nargs += bc_precompile(t->args + t->nargs, "CSS",
                              &t->u.hhs.comp,
                              t->u.hhs.sl,
                              t->u.hhs.pl);

    return t;
}

static test_t *build_header(sieve_script_t *sscript, test_t *t,
                            strarray_t *sl, strarray_t *pl)
{
    assert(t && t->type == BC_HEADER);

    if (t->u.hhs.comp.index == INT_MIN) {
        sieveerror_c(sscript, SIEVE_MISSING_TAG, ":index");
    }

    verify_stringlist(sscript, sl, verify_header);

    t->nargs = bc_precompile(t->args, "i", t->u.hhs.comp.index);

    return build_hhs(sscript, t, sl, pl);
}

static test_t *build_stringt(sieve_script_t *sscript, test_t *t,
                             strarray_t *sl, strarray_t *pl)
{
    assert(t && t->type == BC_STRING);

    verify_stringlist(sscript, sl, verify_utf8);

    return build_hhs(sscript, t, sl, pl);
}

static test_t *build_hasflag(sieve_script_t *sscript, test_t *t,
                             strarray_t *sl, strarray_t *pl)
{
    assert(t && t->type == BC_HASFLAG);

    if (sl) {
        if (!supported(SIEVE_CAPA_VARIABLES)) {
            sieveerror_c(sscript, SIEVE_MISSING_REQUIRE, "variables");
        }

        verify_stringlist(sscript, sl, verify_identifier);
    }

    return build_hhs(sscript, t, sl, pl);
}

static test_t *build_ae(sieve_script_t *sscript, test_t *t,
                        strarray_t *sl, strarray_t *pl)
{
    assert(t);

    verify_patternlist(sscript, pl, &t->u.ae.comp, NULL);

    if (t->u.ae.addrpart == -1) t->u.ae.addrpart = B_ALL;
    t->u.ae.sl = sl;
    t->u.ae.pl = pl;

    t->nargs += bc_precompile(t->args + t->nargs, "CiSS",
                              &t->u.ae.comp,
                              t->u.ae.addrpart,
                              t->u.ae.sl,
                              t->u.ae.pl);

    return t;
}

static test_t *build_address(sieve_script_t *sscript, test_t *t,
                             strarray_t *sl, strarray_t *pl)
{
    assert(t && t->type == BC_ADDRESS);

    if (t->u.ae.comp.index == INT_MIN) {
        sieveerror_c(sscript, SIEVE_MISSING_TAG, ":index");
    }

    verify_stringlist(sscript, sl, verify_addrheader);

    t->nargs = bc_precompile(t->args, "i", t->u.ae.comp.index);

    return build_ae(sscript, t, sl, pl);
}

static test_t *build_envelope(sieve_script_t *sscript, test_t *t,
                              strarray_t *sl, strarray_t *pl)
{
    assert(t && t->type == BC_ENVELOPE);

    verify_stringlist(sscript, sl, verify_envelope);

    return build_ae(sscript, t, sl, pl);
}

static test_t *build_body(sieve_script_t *sscript,
                          test_t *t, strarray_t *pl)
{
    assert(t && (t->type == BC_BODY));

    verify_patternlist(sscript, pl, &t->u.b.comp, verify_utf8);

    if (t->u.b.offset == -1) t->u.b.offset = 0;
    if (t->u.b.transform == -1) t->u.b.transform = B_TEXT;
    if (t->u.b.content_types == NULL) {
        t->u.b.content_types = strarray_new();
        strarray_append(t->u.b.content_types,
                        (t->u.b.transform == B_RAW) ? "" : "text");
    }
    t->u.b.pl = pl;

    t->nargs = bc_precompile(t->args, "CiiSS",
                             &t->u.b.comp,
                             t->u.b.transform,
                             t->u.b.offset,
                             t->u.b.content_types,
                             t->u.b.pl);

    return t;
}

static const struct {
    const char *name;
    unsigned bytecode;
} date_parts[] = {
    { "year",    B_YEAR    },
    { "month",   B_MONTH   },
    { "day",     B_DAY     },
    { "date",    B_DATE    },
    { "julian",  B_JULIAN  },
    { "hour",    B_HOUR    },
    { "minute",  B_MINUTE  },
    { "second",  B_SECOND  },
    { "time",    B_TIME    },
    { "iso8601", B_ISO8601 },
    { "std11",   B_STD11   },
    { "zone",    B_ZONE    },
    { "weekday", B_WEEKDAY },
    { NULL,      0         }
};

static int verify_date_part(sieve_script_t *sscript, char *part)
{
    int i;

    for (i = 0; date_parts[i].name && strcasecmp(date_parts[i].name, part); i++);

    if (!date_parts[i].name) {
        sieveerror_f(sscript, "invalid date-part '%s'", part);
    }

    return date_parts[i].bytecode;
}

static test_t *build_date(sieve_script_t *sscript,
                          test_t *t, char *hn, char *part, strarray_t *kl)
{
    assert(t && (t->type == BC_DATE || t->type == BC_CURRENTDATE));

    if (hn) verify_header(sscript, hn);
    verify_patternlist(sscript, kl, &t->u.dt.comp, NULL);

    if (t->u.dt.comp.index == 0) {
        t->u.dt.comp.index = 1;
    }
    else if (t->u.dt.comp.index == INT_MIN) {
        sieveerror_c(sscript, SIEVE_MISSING_TAG, ":index");
    }

    if (t->u.dt.zone.tag == -1) {
        t->u.dt.zone.tag = B_TIMEZONE;
    }

    t->u.dt.date_part = verify_date_part(sscript, part);
    free(part); /* done with this string */
    t->u.dt.header_name = hn;
    t->u.dt.kl = kl;

    if (t->type == BC_DATE) {
        t->nargs = bc_precompile(t->args, "iZCisS",
                                 t->u.dt.comp.index,
                                 &t->u.dt.zone,
                                 &t->u.dt.comp,
                                 t->u.dt.date_part,
                                 t->u.dt.header_name,
                                 t->u.dt.kl);
    }
    else {
        t->nargs = bc_precompile(t->args, "ZCiS",
                                 &t->u.dt.zone,
                                 &t->u.dt.comp,
                                 t->u.dt.date_part,
                                 t->u.dt.kl);
    }

    return t;
}

static test_t *build_ihave(sieve_script_t *sscript, strarray_t *sa)
{
    test_t *t;
    int i;

    t = new_test(BC_IHAVE, sscript);
    t->u.sl = sa;

    /* check if we support all listed extensions */
    for (i = 0; i < strarray_size(sa); i++) {
        unsigned long long capa = lookup_capability(strarray_nth(sa, i));

        if (!capa) {
            /* need to start ignoring errors immediately in case this ihave
               is part of a testlist with an unknown test later in the list */
            if (!t->ignore_err) t->ignore_err = ++sscript->ignore_err;
        }
        else if (capa & SIEVE_CAPA_IHAVE_INCOMPAT) {
            /* incompatible extension used in ihave - parse error */
            sscript->ignore_err = 0;
            sieveerror_c(sscript, SIEVE_IHAVE_INCOMPAT, strarray_nth(sa, i));
            break;
        }
    }

    t->nargs = bc_precompile(t->args, "S", t->u.sl);

    return t;
}

static test_t *build_mbox_meta(sieve_script_t *sscript,
                               test_t *t, char *extname,
                               char *keyname, strarray_t *keylist)
{
    assert(t);

    canon_comptags(&t->u.mm.comp, sscript);
    t->u.mm.extname = extname;
    t->u.mm.keyname = keyname;
    t->u.mm.keylist = keylist;

    switch (t->type) {
    case BC_MAILBOXEXISTS:
    case BC_MAILBOXIDEXISTS:
    case BC_SERVERMETADATAEXISTS:
        t->nargs = bc_precompile(t->args, "S",
                                 t->u.mm.keylist);
        break;

    case BC_METADATAEXISTS:
    case BC_SPECIALUSEEXISTS:
        t->nargs = bc_precompile(t->args, "sS",
                                 t->u.mm.extname,
                                 t->u.mm.keylist);
        break;

    case BC_SERVERMETADATA:
    case BC_ENVIRONMENT:
        t->nargs = bc_precompile(t->args, "CsS",
                                 &t->u.mm.comp,
                                 t->u.mm.keyname,
                                 t->u.mm.keylist);
        break;

    case BC_METADATA:
    case BC_NOTIFYMETHODCAPABILITY:
        t->nargs = bc_precompile(t->args, "CssS",
                                 &t->u.mm.comp,
                                 t->u.mm.extname,
                                 t->u.mm.keyname,
                                 t->u.mm.keylist);
        break;

    default:
        assert(0);
        break;
    }

    return t;
}

static test_t *build_duplicate(sieve_script_t *sscript, test_t *t)
{
    assert(t && t->type == BC_DUPLICATE);

    switch (t->u.dup.idtype) {
    case B_HEADER:
        verify_header(sscript, t->u.dup.idval);
        break;

    case B_UNIQUEID:
        verify_utf8(sscript, t->u.dup.idval);
        break;

    default:
        t->u.dup.idtype = B_HEADER;
        t->u.dup.idval = xstrdup("Message-ID");
        break;
    }

    if (!t->u.dup.handle) t->u.dup.handle = xstrdup("");
    else verify_utf8(sscript, t->u.dup.handle);

    if (t->u.dup.seconds == -1) t->u.dup.seconds = 7 * 86400; /* 7 days */

    t->nargs = bc_precompile(t->args, "issii",
                             t->u.dup.idtype,
                             t->u.dup.idval,
                             t->u.dup.handle,
                             t->u.dup.seconds,
                             t->u.dup.last);

    return t;
}

#ifdef WITH_JMAP
#include "imap/jmap_api.h"
#include "imap/jmap_mail_query_parse.h"

struct filter_rock {
    strarray_t *path;
    unsigned is_invalid;
};

static void filter_parser_invalid(const char *field, void *rock)
{
    struct filter_rock *frock = (struct filter_rock *) rock;

    if (!frock->is_invalid++) strarray_push(frock->path, field);
}

static void filter_parser_push_index(const char *field, size_t index,
                                     const char *name, void *rock)
{
    struct filter_rock *frock = (struct filter_rock *) rock;
    struct buf buf = BUF_INITIALIZER;

    if (!frock->is_invalid) {
        if (name) buf_printf(&buf, "%s[%zu:%s]", field, index, name);
        else buf_printf(&buf, "%s[%zu]", field, index);
        strarray_pushm(frock->path, buf_release(&buf));
    }
}

static void filter_parser_pop(void *rock)
{
    struct filter_rock *frock = (struct filter_rock *) rock;

    if (!frock->is_invalid) free(strarray_pop(frock->path));
}

static test_t *build_jmapquery(sieve_script_t *sscript, test_t *t, char *json)
{
    json_t *jquery;
    json_error_t jerr;

    assert(t && t->type == BC_JMAPQUERY);

    /* validate query */
    jquery = json_loads(json, 0, &jerr);
    if (jquery) {
        strarray_t path = STRARRAY_INITIALIZER;
        strarray_t capabilities = STRARRAY_INITIALIZER;
        struct filter_rock frock = { &path, 0 };
        jmap_email_filter_parse_ctx_t parse_ctx = {
            NULL,
            &filter_parser_invalid,
            &filter_parser_push_index,
            &filter_parser_pop,
            &capabilities,
            &frock
        };

        strarray_append(&capabilities, JMAP_URN_MAIL);
        strarray_append(&capabilities, JMAP_MAIL_EXTENSION);

        jmap_email_filter_parse(jquery, &parse_ctx);

        if (frock.is_invalid) {
            char *s = strarray_join(&path, "/");

            sieveerror_f(sscript, "invalid jmapquery argument: '%s'", s);
            free(s);
        }

        strarray_fini(&path);
        strarray_fini(&capabilities);
    }
    else {
        sieveerror_f(sscript, "invalid jmapquery format");
    }

    t->u.jquery = json_dumps(jquery, JSON_COMPACT);
    json_decref(jquery);

    free(json);  /* done with this string */

    t->nargs = bc_precompile(t->args, "s", t->u.jquery);

    return t;
}
#else
static test_t *build_jmapquery(sieve_script_t *sscript, test_t *t, char *json)
{
    sieveerror_c(sscript, SIEVE_UNSUPP_EXT, "vnd.cyrus.jmapquery");

    free(json);  /* done with this string */

    return t;
}
#endif /* WITH_JMAP */
